/**
 * 配置信息
 */

function UploadConfig({
                          maxUploadTasks = 10,
                          isMultiUpload = true,
                          multiUploadNum = 5,
                          mapTps = 15
                      } = {}) {
    this.maxUploadTasks = maxUploadTasks;   //最大上传任务数
    this.isMultiUpload = isMultiUpload;            //是否开启分段上传
    this.multiUploadNum = multiUploadNum;  //段大小（MB）
    this.maxTps = mapTps;  //干啥的？
}

function DownloadConfig({
                            maxTaskNum = 10,
                            isMultiDownload = true,
                            multiDownloadNum = 5
                        } = {}) {
    this.maxTaskNum = maxTaskNum;                    //最大下载任务数
    this.isMultiDownload = isMultiDownload;      //是否分段下载？
    this.multiDownloadNum = multiDownloadNum;  //段大小 (MB)
}


module.exports.UploadConfig = UploadConfig;
module.exports.DownloadConfig = DownloadConfig