/**
 * Created on 2017/2/25.
 */
$(document).ready(function () {
    /** 基于jquery的tab切换 */
    $("ul.obs-tab-navi li").each(function () {
        var tabDefault = $(this).attr("tab-default");
        var tabFor = $(this).attr("tab-for");
        $(this).removeClass("obs-tab-active");
        //$("#" + tabFor).hide();
        if (tabDefault) {
            //$("#" + tabFor).show();
            $(this).addClass("obs-tab-active");
        }
    });

    $("ul.obs-tab-navi li").on("click", function () {
        var self = this;
        $("ul.obs-tab-navi li").each(function () {
            var tabFor = $(this).attr("tab-for");
            $(this).removeClass("obs-tab-active");
            //$("#" + tabFor).hide();
            if ($(self).attr("tab-for") == tabFor) {
                //$("#" + tabFor).show();
                $(this).addClass("obs-tab-active");
            }
        })
    });

    //屏蔽鼠标滚动按钮
    $('.area .show').on('mousedown', function (event) {
        if(event.button===1){
            return false;
        }
        $(document).bind("mousemove",function(e2){
            if($("textarea").is(':focus')||$("input").is(':focus')||$("#path").is(':focus')){
                return true;
            }else{
                return false;
            }
        }).mouseup(function(){
            $(document).unbind("mousemove");
        })
    });
});
/**
 * 使用缓存对象的restore状态
 * @type {{updateInterval: number, updateData: null, path: string, bucket: string, data: {}, isUpdate: global.restoreCache.isUpdate}}
 */
global.restoreCache = {
    updateInterval: 2 * 1000,
    updateDate: null,
    path: "",
    bucket:"",
    data: {},
    isUpdate: function(bucket, curPath) {
        if(bucket != global.restoreCache.bucket || curPath != global.restoreCache.path) {
            global.restoreCache.path = curPath;
            global.restoreCache.bucket = bucket;
            global.restoreCache.data = {};
            return true;
        }
        var now = new Date();
        var gap = now - global.restoreCache.updateDate;
        if(gap > global.restoreCache.updateInterval) {
            global.restoreCache.updateDate = now;
            global.restoreCache.data = {};
            return true;
        }
        return false;
    },
    putCache: function(data, dataKey){
        var restoreStat = languageJson.obs_term_notRestored_lable;
        if(data && data.Restore && data.Restore.indexOf('ongoing-request="false"') > -1) {
            restoreStat = languageJson.obs_term_restored_lable
        }
        if(data && data.Restore && data.Restore.indexOf('ongoing-request="true"') > -1) {
            restoreStat = languageJson.obs_term_restoring_lable
        }
        global.restoreCache.data[dataKey] = restoreStat;
        return restoreStat;
    }
}

/**
 * 删除某个指定的桶
 * @param bName
 */
function deleteBucketOK (bName) {
    if ($("#mui-overlay").size() > 0) {
        mui.overlay('off');
    }
    if($('#bucketLists .selected-tr-active .show-span-active').hasClass('mui-icon-extBucket')){//走删除外部桶流程
        bucketAndObjectAction.deleteExtBucket(bName,ExtBucket,currentUserId, function (data) {
            indexAction.writeExBucket(data);
            setTimeout(function () {
                $('.mui-model').showMessage({
                    message: CommonUtils.format(languageJson.obs_term_unlinkBucket_unlinkSuccess_msg, CommonUtils.encodeForHTML(bName)),
                    ok: function () {
                        if ($("#mui-overlay").size() > 0) {
                            mui.overlay('off');
                        }
                        $("#overlay").addClass('mui-hide');
                        return false;
                    },
                    title: languageJson.info
                });
                // 外部桶取消挂载后，桶列表的操作列最后一个应该显示为"更多"，而不是“碎片管理”
                $(".mui-icon-more").css('display','block');
                $(".mui-icon-fragment").css('display','none');
            },100);
            showOverlay();
            //刷新桶列表
            var loading = loadingShow();
            lastBucket = '';
            $("#curBucketName").html('');
            $("#objectNum").html('');
            $("#storageSize").html('');
            bucketAndObjectAction.listBucket(function (err, data) {
                $("#path p").children().each(function () {
                    $(this).remove();
                });
                listBucketUI(err,data,loading);
            });
        });
    }else{
        var loading = loadingShow();
        bucketAndObjectAction.deleteBucket(
            bName,
            function (err,data) {
                if(err){
                    if (errorConfig[err.code]) {
                        if (err.code === 'BucketNotEmpty') {//如果桶不为空，则去列举桶内对象和碎片
                            pageMultipartContext.nowPage = 1;
                            var data = {};
                            data.pageMultipartContext = pageMultipartContext;
                            data.arr = [];
                            data.rubbishDays = -1;
                            async.parallel([
                                    function(callback){
                                        bucketAndObjectAction.listMultipartUploads(bName,'','','','', function (err,data) {
                                            callback(err,data);
                                        },data)
                                    },
                                    function(callback){
                                        bucketAndObjectAction.listObject(bName, 'true','', function (err, data) {
                                            callback(err,data);
                                        })
                                    }
                                ],
                                function(err, results){
                                    loading.close();
                                    var multipData = results[0];
                                    var objectData = results[1];
                                    setTimeout(function () {
                                        if(err){//list接口异常
                                            if(err.code === 'AccessDenied'){
                                                $('.mui-model').showErrorMessage({
                                                    message: CommonUtils.format(global.langData.ERR_CODE_BucketNotEmpty,CommonUtils.encodeForHTML(CommonUtils.substr32( bName)))
                                                });
                                            }else{
                                                $('.mui-model').showErrorMessage({
                                                    message: errorConfig[err.code],
                                                    obsError: obsError(err.code)
                                                });
                                            }
                                        }else if(objectData.Contents.length>0||objectData.CommonPrefixes.length>0){//桶里有对象，直接提示桶不为空
                                            $('.mui-model').showErrorMessage({
                                                message: CommonUtils.format(global.langData.ERR_CODE_BucketNotEmpty,CommonUtils.encodeForHTML(CommonUtils.substr32( bName)))
                                            });
                                        }else if(multipData.arr.length>0){//桶里没有对象，但有碎片
                                            deleteRubbishBucket(bName,true);//清理垃圾桶流程
                                        }else{
                                            global.logger.warn('Delete the bucket:'+bName+' unknown error!');
                                            $('.mui-model').showErrorMessage({
                                                message: CommonUtils.format(global.langData.ERR_CODE_BucketNotEmpty, CommonUtils.encodeForHTML(CommonUtils.substr32(bName)))
                                            });
                                        }
                                    },200);
                                });
                            return false;
                        } else {
                            loading.close();
                            $('.mui-model').showErrorMessage({
                                message: errorConfig[err.code],
                                obsError: obsError(err.code),
                                ok: function(){
                                    if(err.code == 'NoSuchBucket'){
                                        $('#all-refresh-div').click();
                                    }
                                }
                            });
                        }
                    }else{
                        loading.close();
                        global.logger.warn('Delete the bucket:'+bName+' unknown error!');
                    }
                }else{
                    $('.mui-model').showMessage({
                        message: CommonUtils.format(languageJson.deleteBucketSuccess, CommonUtils.encodeForHTML(bName)),
                        ok: function () {
                            if ($("#mui-overlay").size() > 0) {
                                mui.overlay('off');
                            }
                            return false;
                        },
                        title: languageJson.info
                    });
                    //刷新桶列表
                    lastBucket = '';
                    $("#curBucketName").html('');
                    $("#objectNum").html('');
                    $("#storageSize").html('');
                    bucketAndObjectAction.listBucket(function (err, data) {
                        $("#path p").children().each(function () {
                            $(this).remove();
                        });
                        listBucketUI(err,data,loading);
                    });
                    if(loading){
                        loading.close();
                    }
                    showOverlay();
                }
            }
        );
    }
}

function getChoseObjKey() {
    var hiddenData = $("#objLists tr.selected-tr-active>.hiddenObjData").text();
    var jsonObj = JSON.parse(hiddenData);
    var jsonName = jsonObj.name;
    var objKey = "";
    if (activeIsFolder()) {
        objKey = jsonName;
    } else {
        objKey = getCurrPath() + jsonName;
    }
    return objKey;
}

function getChoseObjType() {
    var hiddenData = $("#objLists tr.selected-tr-active>.hiddenObjData").text();
    var jsonObj = JSON.parse(hiddenData);
    var jsonType= jsonObj.StorageClass;
    var objType = "";
    if (activeIsFolder()) {
        objType = "--";
    } else {
        objType = jsonType;
    }
    return objType;
}

function getChoseObjName() {
    var hiddenData = $("#objLists tr.selected-tr-active>.hiddenObjData").text();
    var jsonObj = JSON.parse(hiddenData);
    var objName = jsonObj.name;
    if(activeIsFolder()) {
        var splitArray = jsonObj.name.split("/");
        objName = splitArray[splitArray.length - 2] + "/";
    }
    return objName;
}

function activeIsFolder() {
    return $("#objLists tr.selected-tr-active").attr("data-type") === "folder";
}

function getChoseObSize() {
    var hiddenData = $("#objLists tr.selected-tr-active>.hiddenObjData").text();
    var jsonObj = JSON.parse(hiddenData);
    if (activeIsFolder()) {
        return "--";
    } else {
        return jsonObj.dataSize;
    }
}

function getChoseObjKeyWithBucket() {
    var key = getChoseName();
    return $("#curBucketName").html() + key;
}




