
var en={
    "500": "Internal server error.",
    "501": "This function is not supported currently.",
    "503": "The service is unavailable.",
    "about": "About",
    "aboutOBSBrowser": "About OBS Browser",
    "AccessDenied": "You do not have permission to perform this operation. Contact the administrator to obtain permission.",
    "accessKey": "Access Key ID",
    "account": "Account Name",
    "accountManage": "Manage Account",
    "accountName": "Account Name",
    "accountNameHint": "Enter a name for this account. OBS clients use this name to distinguish the account from other accounts.",
    "accountNameMsg": "Enter an account name.",
    "AccountProblem": "1 email address can be associated with 1 account only.",
    "aclConfig": "Configure Object ACL",
    "aclPermissions": "Configure Bucket ACL",
    "aclPermissionsSuccess": "Bucket ACL configured successfully.",
    "add": "Add",
    "add_account_user_valid": "The domain name cannot contain \\.",
    "addAccount": "Add Account",
    "addAccountHint": "Enter account information and click Save.",
    "addAclDescription": "A bucket ACL controls access to the bucket. The owner of the bucket can use the bucket ACL to grant user groups with specific access permissions.",
    "addLifeCycle": "You can create lifecycle rules to automatically delete objects or transition storage classes for objects that meet specified conditions.",
    "addLogDescription": "Access requests can be logged for analysis or auditing.",
    "addNewAccount": "Add Account",
    "addNewAccountDescription": "For details about how to add accounts, click",
    "obs_term_accountManager_aboutAKSK_msg": "If you have created access keys, obtain the access key ID and its secret access key from the credentials.csv file downloaded from OBS Console. <span id='HCSO'>You can also click <a id='toIamAddNewAccountKnowMore'>here</a> to create a pair of access keys on the Access Keys tab.</span>",
    "aimBucket": "Save Logs To",
    "aimPrefix": "Log File Name Prefix",
    "all": "All statuses",
    "allowedHeader": "Allowed Header",
    "allowedHeaderHint": "Enter one allowed header per line. Each line can contain only one asterisk (*). Allowed headers cannot contain spaces or the following special characters: &:<",
    "allowedHeaderInTable": "Allowed Header",
    "allowedHeader_length_valid": "The Allowed Header contains a maximum of 1024 characters.",
    "allowedName": "Allowed Origin",
    "allowedNameHint": "Enter one allowed origin per line. Each line can contain only one asterisk (*). ",
    "allowedNameInTable": "Allowed Origin",
    "allowNameNotNull": "The Allowed Origin cannot be left blank.",
    "allowName_length_valid": "The Allowed Origin contains a maximum of 1024 characters.",
    "AmbiguousGrantByEmailAddress": "1 email address can be associated with 1 account only.",
    "anonymousUser": "Anonymous User",
    "anonymousUserReadPermissions": "Grant anonymous user the read-only permission.",
    "authorizedUser": "Grantee",
    "BadDigest": "The MD5 value of the object content specified by the client is inconsistent with that received by the system.",
    "browse": "Browse",
    "BucketAlreadyExists": "The requested bucket name already exists. Bucket namespace is shared by all users in the system. Select a different name and retry.",
    "BucketAlreadyOwnedByYou": "The user has created a bucket with this name.",
    "bucketLifecycle": "Lifecycle Rule",
    "bucketLifecycleHint": "You can set bucket lifecycle here.",
    "bucketLoggingConfig": "Bucket log settings",
    "bucketLoggingConfigHint": "You can set bucket log information here.",
    "bucketManage": "Manage Bucket",
    "bucketName": "Bucket Name",
    "bucketNameCriterion": "The bucket name must contain 3 to 63 characters, including lowercase letters, digits, hyphens (-), and periods (.), and it must start and end with a digit or lowercase letter.",
    "bucketNameCriterion2": "3 to 63 lowercase letters, digits, periods (.), and hyphens (-).",
    "bucketNameHint": "The bucket name contains letters, digits, and special characters and must be unique.",
    "bucketNameIsNotNull": "The bucket name cannot be left blank.",
    "bucketNameNotIP": "The bucket name cannot be an IP address.",
    "bucketNameNotNull": "The bucket name cannot be left blank.",
    "bucketNameNotSpecail": "The bucket name cannot contain two consecutive periods (.) or periods (.) and hyphens (-) adjacent to each other.",
    "bucketNameRepeat": "The bucket name already exists.",
    "bucketNameRule": "Bucket naming rules:",
    "accountNameTipsMsg": "An account name is a unique identifier of an OBS Browser account, different from the account registered with the public cloud service.",
    "serverAddrTipsMsg": "Obtain the endpoint address from the official website of the cloud service provider. If the server uses a certificate issued by a non-authoritative organization, enabling certificate verification will result in OBS Browser connection failure.\n",
    "accountNamePlaceHolder": "Enter a self-defined account name.",
    "bucketNameRule0": "- The name must be globally unique in OBS.",
    "bucketNameRule1": "- The name must contain 3 to 63 characters. Only lowercase letters, digits, hyphens (-), and periods (.) are allowed.",
    "bucketNameRule2": "- The name cannot start or end with a period (.) or hyphen (-), and cannot contain two consecutive periods (.) or contain a period (.) and a hyphen (-) adjacent to each other.",
    "bucketNameRule3": "- The name cannot be an IP address.",
    "bucketNameRule4": "- Cannot contain two consecutive periods (.)",
    "bucketNameRule5": "- Cannot contain periods (.) and hyphens (-) adjacent to each other",
    "bucketNameRule6": "- If the name contains any periods, a security certificate verification message may appear when you access the bucket or its objects by entering a domain name.",
    "BucketNotEmpty": "Deletion failed. Check whether objects exist in the bucket or log in to OBS Console to check whether objects of historical versions exist in the bucket.",
    "bucketPolicy": "Bucket policy",
    "bucketPolicyConfig": "Configure Bucket Policy",
    "bucketPolicyDemo": "Example",
    "bucketPolicyHint": "Add, edit, or delete the bucket policy in the text area below.",
    "bucketProperty": "Basic Information",
    "by_date": "By date",
    "by_days": "By day",
    "cacheTimeNotNull": "The Cache Duration cannot be left blank.",
    "cancel": "Cancel",
    "cancelAll": "Delete All",
    "catheTime": "Cache Duration (s)",
    "catheTime1": "Cache Duration (s):",
    "changeAccount": "Switch account",
    "changeAccountWithTask": "Account switchover will suspend tasks. Are you sure you want to continue?",
    "checkDownObject": "Select the object that you want to download.",
    "checkFalseToUpdate": "Integrity check failed. Click OK to perform the upgrade again.",
    "checkTrueToDecompression": "Integrity check succeeded. Decompression starts.",
    "checkVersion": "Check for Upgrade",
    "checkVersionFail": "Failed to check the update. Click OK to check again, or click Cancel to exit the check.",
    "chinese": "中文（简体）",
    "cleanUp": "Clear",
    "close": "Close",
    "disable": "Disable",
    "disabled": "Disabled",
    "enable": "Enable",
    "enabled_001": "Enabled",
    "compatibleS3Storage": "Other object storage services",
    "conditionScope": "Condition uses IpAddress, NotIpAddress, and ws:SourceIp keys. Note that the value of aws:sourceIp uses the CIDR method described in RFC 2632.",
    "config": "Configure",
    "copy": "Copy",
    "corsAllowedHeaderNoComma": "An allowed header cannot contain commas (,).",
    "corsConfig": "Configure CORS Rule",
    "corsConfigDescription": "Cross-origin resource sharing (CORS) rules facilitate cross-domain requests among clients.",
    "corsConfigSuccess": "CORS rule configured successfully.",
    "corsExposeHeaderNoComma": "An exposed header cannot contain commas (,).",
    "CorsList": "CORS list",
    "corsResouceExample": "https://www.example.com",
    "corsResouceNoComma": "An allowed origin cannot contain commas (,).",
    "CorsRule": "Add CORS Rule",
    "obs_term_bucketCors_delCorsRule_wintitle": "Delete CORS Rule",
    "CorsRuleNotMoreThan100": "The number of CORS rules has reached the upper limit of 100.",
    "create": "Create",
    "createBucket": "Create Bucket",
    "createBucket2": "Create",
    "createBucketSuccess": "Bucket {0} created successfully.",
    "createBucketTitle": "Create Bucket",
    "createFolder": "Create Folder",
    "createFolderSuccess": "Folder {0} created successfully.",
    "createTime": "Created",
    "createTimeInTable": "Created",
    "createUrl": "Object URL",
    "CredentialsNotSupported": "This request does not support certificate verification.",
    "currentLog": "Current log",
    "dataOutDate": "Expiration Date:",
    "dataOutDays": "Expires in:",
    "dataOutTime": "Deleted after",
    "dateNotMoreThanToday": "The expiration date cannot be earlier than today.",
    "day": " days",
    "debrisNum": "Fragments",
    "debrisSize": "Fragment Size",
    "decompressionFailReason": "Decompression failed.",
    "defaultPosition": "Default location",
    "defualtPath": "Default",
    "delete": "Delete",
    "deleteAccount": "Delete Account",
    "deleteAllMultipartErr": "Deletion failed.",
    "deleteBucket": "Delete Bucket",
    "deleteBucket2": "Delete",
    "deleteBucketErrMsg": "Bucket {0} could not be deleted. The bucket to be deleted may contain fragments generated due to multipart upload failures or some users are uploading objects to the bucket in multipart mode.",
    "deleteBucketSuccess": "Bucket {0} deleted successfully.",
    "deleteFail": ". Deletion failed.",
    "deleteRule": "Delete Rule",
    "deleteSuccess": "Deletion succeeded.",
    "describe_object_ruleThree": "The name cannot start or end with a period (.) or a slash (/).",
    "detection": "Check",
    "down": "Download",
    "downFailReason": "Download failed.",
    "downOverToDecompression": "Download complete. Decompressing it. Please wait.",
    "downUpdateFile": "Download OBS Browser&nbsp;",
    "DTStorage": "OBS",
    "eastChina": "East China",
    "EBADF": "Internal error. Try again later.",
    "EBUSY": "The target file has been occupied.",
    "edit": "Edit",
    "editAccount": "Edit Account",
    "editAccountInfo": "Configure Account",
    "editPermissions": "ACL Write",
    "EISDIR": "Unknown error.",
    "email": "Email Address:",
    "emailFormatIsNotRight": "Incorrect email format.",
    "endpointRule": "IP address or domain name:port",
    "ENOENT4058": "The path cannot be found or created. Check whether the path exists, is too long, or contains the following special characters that are not allowed in Windows systems: \\/:*?\"<>|",
    "ENOSPC": "Insufficient disk space.",
    "EntityTooLarge": "The size of the object to be uploaded cannot exceed the upper limit of 5 GB.",
    "EntityTooSmall": "The size of the object to be uploaded cannot be smaller than the lower limit.",
    "EPERM": "No file read or write permission.",
    "error": "Error",
    "errorMessage": "Error",
    "ExBucket": "Add External Bucket",
    "exBucketMsg": "Add a bucket shared by other account.",
    "exBucketPage": "Add External Bucket",
    "exBucketSuccess": "External bucket {0} added successfully.",
    "expireTime": "Expiration Time:",
    "exposeHeader": "Exposed Header",
    "exposeHeaderHint": "Enter one exposed header per line. Exposed headers cannot contain spaces or the following special characters: *&:<",
    "exposeHeaderInTable": "Exposed Header",
    "exposeHeader_length_valid": "The Exposed Header contains a maximum of 1024 characters.",
    "fail": "Failed",
    "failed": "Failed",
    "failedReason": "Causes",
    "file": "File",
    "folder": "Folder",
    "folderName": "Folder Name",
    "folderNameHint": "The name can contain letters, digits, and special characters.",
    "folderNameTooLarge": "The absolute path of a folder cannot exceed 1023 bytes.",
    "fullControl": "Full Control",
    "help": "Help",
    "here": " here",
    "hint": "Information",
    "hintInfo": "Information",
    "hour": "h",
    "HTTPPermissions": "Restrict access to sites cited by specific HTTP",
    "HTTPPermissionsHint": "Assume you have a website whose domain name is www.example.com or example.com and has default links pointing to pictures and videos in examplebucket of OBS browser. In this situation, all OBS browser resources are private and can only be accessed by OBS accounts that create these resources. If you want to access objects from your website, you can add a storage bucket policy to grant the s3:GetObject permission with the aws:referer condition key that specifies websites where GET requests come from. The following policy specifies the StringLike condition with the aws:Referer condition key.",
    "httpRefererPermissions": "Ensure that requests sent by your browser contain http referrer headers.",
    "httpRefererPermissionsHint": "You can add effect deny to a storage bucket policy to better control access to objects in examplebucket. The following example shows that effect deny overwrites any permission granted to data in examplebucket by other methods (such as ACL or user policy).",
    "icon": "Icon",
    "InArrearOrInsufficientBalance": "The account balance is overdue or insufficient.",
    "IncompleteBody": "The number of upload object bytes is smaller than that specified by the Content-Length field in the HTTP header.",
    "IncorrectNumberOfFilesInPostRequest": "Each POST request must contain one file to be uploaded.",
    "InlineDataTooLarge": "The length of Inline Data exceeds the upper limit.",
    "inputAccessKey": "Enter an access key ID.",
    "inputAccountName": "Enter a self-defined account name.",
    "inputAccountNameIsLong": "The account name contains a maximum of 50 characters.",
    "inputAccessKeyIsLong": "The Access Key ID contains a maximum of 256 characters.",
    "inputSecretKeyIsLong": "The Secret Access Key contains a maximum of 256 characters.",
    "inputEmail": "Enter an email.",
    "inputFeedbackMsg": "Enter your feedback or suggestions. ",
    "inputFeedbackMsg2": "Enter your feedback or suggestions.",
    "inputFolderName": "Enter a folder name",
    "InputFolderName": "This field cannot be left blank.",
    "inputPhoneNum": "Enter a phone number.",
    "inputRedirectIP": "Enter a redirection address.",
    "inputRuleID": "Enter a rule name.",
    "inputRulePrefix": "Enter an object name prefix.",
    "inputSecretKey": "Enter a secret access key.",
    "inputTrueIP": "Enter a valid IP address.",
    "inputVerification": "The name cannot contain the following special characters: \\ / : * ? \" < > |",
    "inputVerification1": "Cannot start or end with a period (.) or a slash (/).",
    "inputVerification3": "Cannot contain two or more consecutive slashes (/).",
    "inputVerificationLogMsg": "The prefix cannot contain special characters, including <>?|:\\*\".",
    "inputVerificationLogMsg1": "The prefix cannot start with a period (.).",
    "inputVerificationMsg1": "- The name cannot contain the following special characters: \\ / : * ? \" < > |",
    "inputVerificationMsg2": "- The name cannot start or end with a period (.) or a slash (/).",
    "inputVerificationMsg3": "- Any single slash (/) separates and creates multiple levels of folders at once.",
    "intendTime": "Estimated Time",
    "InternalError": "Internal error. Try again later.",
    "InvalidAccessKeyId": "Invalid Access Key ID or Secret Access Key.",
    "InvalidAddressingHeader": "The anonymous role must be specified.",
    "InvalidArgument": "Invalid parameter.",
    "InvalidBucketName": "Invalid bucket name.",
    "InvalidDigest": "The value of Content-MD5 specified in the HTTP header is invalid.",
    "InvalidLocationConstraint": "Incorrect region.",
    "InvalidPart": "One or more specified parts cannot be found. The parts may not be uploaded, or the specified entity tag does not match the parts' entity tag.",
    "InvalidPartOrder": "The list of parts is not in ascending order. Parts must be sorted by part number.",
    "InvalidPayer": "All access requests to this object are invalid.",
    "InvalidPolicyDocument": "The content of the form does not meet the conditions specified in the policy document.",
    "InvalidRange": "The requested range cannot be obtained.",
    "InvalidRedirectLocation": "Invalid redirection address.",
    "InvalidRequest": "Invalid request.",
    "InvalidSecurity": "The provided Secret Access Key is invalid. ",
    "InvalidStorageClass": "The specified storage class is invalid.",
    "InvalidTargetBucketForLogging": "This operation can be performed only when the log delivery user group has been granted with the write permission to the bucket where logs are saved and the read permission to the bucket ACL.",
    "InvalidTargetBucketForLogging1": "The owner of the current bucket and that of the target bucket must be the same.",
    "InvalidURI": "The URI cannot be resolved.",
    "IPNotNull": "The server address cannot be left blank.",
    "isAllUploadWarning": "If multipart is not enabled, the upload object cannot exceed 5 GB.",
    "isAutoUpdate": "Enable automatic update check",
    "isAutoUpdateHint": "If this item is selected, the software will check updates once upon startup.",
    "isDeleteAccount": "Are you sure you want to delete this account?<br><span style=\"color: #7f8181\">After an account is deleted, all tasks under the account will be deleted and cannot be recovered. Exercise caution when performing this operation.</span>",
    "isDeleteAllMultipart": "Are you sure you want to delete all fragments in the bucket?",
    "obs_term_fragmentManage_delAllFragmentWarn_msg": "Deleted fragments cannot be recovered. Before performing this operation, ensure that all upload tasks have been completed. Upload tasks will fail if fragments are deleted before they are completed. Exercise caution when performing this operation.",
    "isDeleteMultipart": "Are you sure you want to delete the  fragment?",
    "obs_term_fragmentManage_delFragmentWarn_msg": "Deleted fragments cannot be recovered. Before performing this operation, ensure that the upload task has been completed. The upload task will fail if fragments are deleted before it is completed. Exercise caution when performing this operation.",
    "isDeleteRubBucket": "Multipart upload tasks remain in the bucket. Are you sure you want to delete the bucket?",
    "obs_term_bucketFragment_delFragmentSuccess_msg": "Fragment {0} deleted successfully.",
    "obs_term_bucketFragment_delAllFragmentSuccess_msg": "Fragments deleted successfully.",
    "obs_term_bucketLifecycle_noTransitionTime_msg": "Set at least one transition time or the expiration time.",
    "obs_term_bucketLifecycle_noTransitionTime_msg1": "Set at least one transition time or the expiration time.",
    "isHttps": "Enable HTTPS",
    "isHttpsHint": "All data will be encrypted after this is selected.",
    "isMultiUploadWarning": "After multipart upload is enabled, junk data may be generated if the system encounters an anomaly during object upload.",
    "isOpen": "Whether to enable",
    "isOverwritePower": "Retain existing permission when overwriting existing files.",
    "isOverwritePowerHint": "Retain the existing permission when uploading, copying, or moving existing files.",
    "isSureCancel": "Are you sure you want to delete the selected tasks? ",
    "isSureCancelAll": "Are you sure you want to delete all unfinished tasks?",
    "isSureDeleteBucket": "Are you sure you want to delete the following bucket?",
    "isSureDeleteObjcet": "Are you sure you want to delete the following object?",
    "isSureDeleteFolder": "Are you sure you want to delete the following folder?",
    "obs_term_delFolder_wintitle": "Delete Folder",
    "obs_term_objectManage_delMultiObject_msg": "Are you sure you want to delete the following {0} objects?",
    "obs_term_objectManage_delMultiFolder_msg": "Are you sure you want to delete the following {0} folders?",
    "obs_term_deleteWarn_msg": "Deleted data cannot be recovered. Exercise caution when performing this operation.",
    "isSureUseHttp": "HTTP may cause security risks.",
    "isSureUseHttp1": "HTTP may cause security risks. If you want to use HTTP, change the server port to the HTTP port on the Manage Account page.",
    "isSureUseHttps": "If you want to use HTTPS, change the server port to the HTTPS port on the account management page.",
    "isTautology": "Retry?",
    "isUpdateNow": "New version detected. Download now?",
    "KeyTooLong": "The absolute path of an object cannot exceed 1023 bytes.",
    "knowMore": "Learn more",
    "lastUpdateTime": "Last Modified",
    "operating": "Operation",
    "lifecycleConfig": "Configure Lifecycle Rule",
    "lifecycleConfigSuccesss": "Lifecycle rule configured successfully.",
    "lifecycleMessage": "To add a rule by object name prefix, you must first delete the rule configured for the entire bucket.",
    "lifecycleRule": "Create Lifecycle Rule",
    "obs_term_bucketLifecycle_configAllBucket_tip": "To configure a rule for the entire bucket, you must first delete all rules configured by prefix.",
    "obs_term_bucketLifecycle_delLifecycleRule_wintitle": "Delete Lifecycle Rule",
    "lifecycleRule1": "A rule takes effect within one day after it is configured. Proceed with caution when configuring a rule since batch deleted data cannot be recovered.",
    "lifecycleRule2": "If you configure a rule and apply it to objects with a specified object name prefix, make sure that the prefix does not overlap with any of the other configured prefixes.",
    "lifecycleRuleNotMoreThan100": "Add a maximum of 100 lifecycle rules.",
    "lifecycleType": "Applies To",
    "link": "URL",
    "loggingConfig": "Configure Logging",
    "loggingConfigSuccess": "Logging enabled successfully.",
    "obs_term_bucketLog_closeLogManage_msg": "Logging disabled successfully.",
    "loggingIsEnable": "Enable",
    "loggingUser": "Log Delivery User",
    "loginFirst": "Please log in first.",
    "obs_term_bucketLogging_rule1_valid": "--Select a bucket--",
    "obs_term_bucketLogging_rule2_valid": "The prefix cannot contain the following special characters: \\ : * ? \" < > |",
    "obs_term_bucketLogging_rule3_valid": "The prefix cannot start with a slash (/) or contain two or more consecutive slashes (/).",
    "obs_term_bucketLogging_rule4_valid": "The prefix cannot start or end with a period (.).",
    "obs_term_bucketLogging_rule5_valid": "Enter a maximum of 254 characters.",
    "obs_term_bucketLogging_targetBucketDelErr_msg": "The bucket {0} has been deleted. Select another one.",
    "MalformedACLError": "Bad request. Contact the customer service.",
    "MalformedPolicy": "The bucket policy is invalid. Configure it again.",
    "MalformedPOSTRequest": "The body of the POST request is not well-formed multipart or formal data.",
    "MalformedXML": "The error occurs when you send an XML whose configuration item's format is incorrect.",
    "MaxMessageLengthExceeded": "The request is too long.",
    "MaxPostPreDataLengthExceededError": "The POST request fields prior to the file to be uploaded are too large.",
    "maxTaskNum": "Max. Number of Tasks:",
    "MetadataTooLarge": "The size of the metadata headers exceeds the upper limit.",
    "method": "Allowed Method",
    "methodInTable": "Allowed Method",
    "MethodNotAllowed": "The specified method is not permitted on the requested resource.",
    "methodNotNull": "The Allowed Method cannot be left blank.",
    "minute": "m",
    "MissingContentLength": "HTTP headers must contain the Content-Length field.",
    "MissingRequestBodyError": "The request body cannot be left blank.",
    "MissingRequiredParameter": "The request message lacks the required attributes.",
    "MissingSecurityHeader": "A required header is missing.",
    "more": "More",
    "moreUserPermissions": "You can grant permission to multiple accounts if allowed.",
    "moreUserPermissionsHint": "The following policy grants the s3:PutObject and s3:PutObjectAcl permission to multiple OBS accounts and requires all operation requests contain public-read standard ACL.",
    "MOSStorage": "OBS",
    "multiDownload": "Multipart Download",
    "multiDownloadNum": "Part Size (MB)",
    "multiDownloadNumHint": "If this is selected, a large file will be downloaded through multiple parallel threads.",
    "multipart": "Manage Fragment",
    "obs_term_bucketFragment_delFragment_wintitle": "Delete Fragment",
    "multipartIsNULL": "The bucket does not contain fragments.",
    "multipartMsg": "Fragments refer to data segments generated during the process of multipart uploading or upon failures of multipart uploading tasks. Fragments occupy storage space and incur costs, but cleaning up fragments of a running upload task may result in loss of the task progress. It is recommended that you clean up unneeded fragments regularly.",
    "multiUpload": "Multipart Upload",
    "multiUploadNum": "Part Size (MB)",
    "multiUploadNumHint": "If this is selected, a large file will be uploaded through multiple parallel threads.",
    "name": "Object",
    "NetworkingError": "The connection timed out.",
    "NetworkingError1": "The connection timed out.",
    "newVersionInstallFail": "Update failed.",
    "no": "No",
    "NoLimit": "Unlimited",
    "northchina": "North China",
    "NoSuchBucket": "The specified bucket does not exist.",
    "NoSuchFile": "The file or folder does not exist.",
    "NoSuchKey": "The object does not exist.",
    "NoSuchUpload": "The specified multipart upload task does not exist, or the multipart upload task has been aborted or completed.",
    "NoSuchVersion": "The specified version ID does not match any existing versions.",
    "NotImplemented": "The provided header implies a function that is not implemented yet.",
    "notMoreThan20Task": "Configure a maximum of 20 parallel tasks.",
    "notMoreThan20ThreadDown": "Configure a maximum of 20 parallel download threads.",
    "notMoreThan20ThreadUpload": "Configure a maximum of 20 parallel upload threads.",
    "notMoreThan50Account": "A maximum of fifty accounts can be stored on each client.",
    "notMoreThan5GB": "The part size must range from 5 MB to 5120 MB.",
    "NotSignedUp": "The account has not been registered with the system. Only a registered account can be used.",
    "NotSuchBucketPolicy": "The specified bucket policy does not exist.",
    "object": "Name",
    "objectName": "Object Name",
    "objectPrefixSearch": "Enter an object name prefix.",
    "ok": "OK",
    "oneOrMoreDeleteObjcet": "Select the objects that you want to delete.",
    "onlineHelp": "Online Help",
    "operation": "Operation",
    "OperationAborted": "Your operation is conflicting with another user's operation. Try again later.",
    "others": "Others",
    "owerUserID": "Account ID",
    "owerUserName": "Owner",
    "path": "Path",
    "pathNotExist": "Nonexistent target path. Select another path.",
    "pause": "Suspend",
    "pauseAll": "Suspend All",
    "paused": "Suspended",
    "PermanentRedirect": "The bucket must be accessed through a specific endpoint.",
    "permissions": "Permission",
    "phoneNumFormatIsNotRight": "Incorrect phone number. Please retry. Currently, only fixed-line phones and mobile phones registered in the region of China are supported. Examples: 0755-28782000 (fixed-line phone), or 13800138000 (mobile phone)",
    "pictureMsg": "Upload a maximum of 2 MB images.<br>Only JPG, GIF, BMP, PNG, and JPEG images can be uploaded.",
    "placeInputName": "Enter a name for the bucket.",
    "point": ".",
    "policyConfig": "Configure Bucket Policy",
    "policyConfigSuccess": "Bucket policy configured successfully.",
    "PortIsNotNull": "The server address must contain a valid port number.",
    "PreconditionFailed": "At least 1 specified precondition is not met.",
    "prefix": "Prefix",
    "prefix1": "Object name prefix",
    "prefixHint": "If no prefix is specified, the configuration applies to the entire bucket lifecycle.",
    "prefixSearchInfo": "Enter an object name prefix.",
    "progress": "Progress",
    "property": "Basic",
    "quitWithTask": "Tasks are running. Shutting down OBS Browser will suspend the running tasks, and you need to run the tasks when you start OBS Browser again. Are you sure you want to exit?",
    "readPermissions": "Bucket Read",
    "readPermissions_object": "Object Read",
    "realDelBucket": "Are you sure you want to delete the current bucket?",
    "Redirect": "Temporarily redirected",
    "refresh": "Refresh",
    "region": "Region",
    "region1": "Region",
    "regionMsg": "Enter the region of the bucket.",
    "RegionNameNotMatch": "Incorrect region.",
    "regUser": "Registered User",
    "remainingTime": "Remaining Time",
    "remark": "Remarks",
    "RequestIsNotMultiPartContent": "POST requests of a bucket must be closed multipart or form data.",
    "RequestTimeout": "The request timed out.",
    "RequestTimeTooSkewed": "Time difference is longer than 15 minutes between the client and server.",
    "RequestTorrentOfBucketError": "The request for the torrent file of a bucket is forbidden.",
    "restartToLanguageEffect": "Restart OBS Browser for the language change to take effect.",
    "ruleID": "Rule Name",
    "ruleIdDescription": "Customize unique rule names.",
    "ruleIDInTable": "Rule Name",
    "ruleIDRepeat": "Duplicate rule name.",
    "rulePathRepeat": "The prefix partially overlaps with an existing prefix. Enter a new prefix.",
    "run": "Run",
    "runAll": "Run All",
    "running": "Running",
    "save": "Save",
    "saveBucketInfo": "Save bucket information:",
    "search": "Search",
    "second": "s",
    "secretKey": "Secret Access Key",
    "select": "Please select",
    "selectBucket": "Select a bucket.",
    "selectDeleteBucket": "Select a bucket from the bucket list.",
    "selectDeleteObject": "Select the object that you want to delete.",
    "selectObjcet": "Select a bucket object.",
    "selectTime": "Select the time.",
    "sequenceNumber": "No.",
    "Serveice Unavailable": "The service is unavailable.",
    "serviceAddress": "Server Address",
    "serviceAddressHint": "Server address format: {Server IP address or domain name}:{Server port}",
    "share": "Share",
    "showLanguage": "Language",
    "showLanguageHint": "This sets the GUI language.",
    "SignatureDoesNotMatch": "Incorrect Access Key ID or Secret Access Key.",
    "size": "Size",
    "SlowDown": "Do not send requests so frequently.",
    "someObjectDelErr": "Failed to delete some objects. Try again later.",
    "someObjectDownErr": "Failed to download some objects. Try again later.",
    "southchina": "South China",
    "specailAimLifecycle": "The prefix is mandatory. You can only set lifecycle to the specified directory.",
    "specialIPPermissions": "Restrict access permission for specific IP address",
    "specialIPPermissionsHint": "The following example grants objects in the specified bucket the permission to operate OBS browser, but only operation requests from the specified IP address range have this permission.The IP address range for this example is 54.240.143.*, except 54.240.143.188.",
    "speed": "Speed",
    "startInstallAndRestart": "The software package is decompressed. Are you sure you want to upgrade?",
    "obs_browser_upgrade_msg": "Do not manually run OBS Browser during the upgrade. Upon completion of the upgrade, OBS Browser will restart automatically.",
    "obs_browser_upgradeTip_label": "What's New  ",
    "startUse": "Enable",
    "status": "Status",
    "statusInTable": "Status",
    "enabled": "Enabled",
    "stop": "Disabled",
    "stopUse": "Disable",
    "storageType": "Service",
    "storageTypeHint": "Select a storage service that you want to use. The value is set to OBS by default.",
    "strategy": "Applies To",
    "submit": "Save",
    "submitFeedbackFailed": "Failed to submit the feedback.",
    "submitFeedbackSuccess": "Feedback submitted successfully.",
    "success": "Succeeded",
    "sureDeleteAllCorsRule": "Are you sure you want to delete all the CORS rules?",
    "sureDeleteAllLifecycleRule": "Are you sure you want to delete all the lifecycle rules?",
    "sureDeleteCorsRule": "Are you sure you want to delete the CORS rule?",
    "sureDeleteLifecycleRule": "Are you sure you want to delete the lifecycle rule?",
    "sureQuitClint": "Are you sure you want to exit?",
    "switchLanguageMsg": "The language change takes effect after the OBS Browser is restarted.",
    "systemConfig": "System Configuration",
    "taskManagement": "Manage Tasks",
    "taskNum": "Number of Tasks:",
    "taskNumHint": "Configure the maximum number of tasks.",
    "taskWarningInfo": "The task list contains uncompleted tasks. Continue to execute them.",
    "telephoneNum": "Telephone No.:",
    "TemporaryRedirect": "Requests are redirected to the bucket while the DNS is being updated.",
    "to": "To",
    "to1": "To ",
    "toAllBucket": "Bucket",
    "TooManyBuckets": "The number of buckets has reached the upper limit.",
    "toPrefix": "Object name prefix",
    "totalObjectNum": "Objects",
    "totalObjectNum1": "Objects",
    "obs_term_bucketCreatedTotal_msg": "Number of created buckets",
    "obs_term_bucketAvailableQuota_msg": "Available quota of buckets",
    "obs_term_bucketMountedTotal_msg": "External buckets",
    "obs_term_createBucket_region_hint": "Enter a region name.",
    "obs_term_createBucket_name_hint": "Enter a bucket name.",
    "obs_term_mountBucket_name_hint": "Enter an external bucket name.",
    "obs_term_delObject_disableVersion_tip": "- If versioning is disabled, the selected data will be permanently deleted.",
    "obs_term_delObject_enableVersion_tip": "- If versioning is enabled, the selected data will be removed and stored in the list of Deleted Objects on the Objects page of OBS Console. You can log in to OBS Console and cancel the deletion to restore the data as needed.",
    "obs_task_uploadFile_upperLimit_msg": "You can upload a maximum of 500 files at a time. It is recommended that you use folders if the number of files to be uploaded is greater than 500.",
    "obs_task_uploadFile_limit_msg": "You can upload a maximum of 500 files at a time.",
    "obs_task_uploadObject_upperLimit_msg": "You can upload a maximum of 500 files and folders in one batch.",
    "obs_task_uploadObject_limit_msg": "You can upload a maximum of 500 objects at a time.",
    "obs_term_previous_button": "Previous",
    "obs_term_next_button": "Next",
    "common_term_previous_tip": "Already the first page.",
    "common_term_next_tip": "Already the last page.",
    "Transmission": "Transfer",
    "type": "Type",
    "undefinedError": "Other error",
    "UnexpectedContent": "This request does not support the content field.",
    "UnknownEndpoint": "Invalid IP address.",
    "UnresolvableGrantByEmailAddress": "The provided email address does not match any accounts in the record.",
    "updateVersion": "Upgrade version",
    "updating": "Upgrade OBS Browser",
    "upload": "Upload",
    "uploadAttachments": "Upload Image",
    "uploadFile": "Upload File",
    "uploadFolder": "Upload Folder",
    "uploadId": "Segment SN",
    "uploadPicture": "Upload images",
    "uploadSizeMsg": "The attachment cannot exceed 2 MB.",
    "uploadTypeMsg": "The image type does not meet requirements.",
    "upToDateVersion": "It is already the latest version.",
    "usedStorage": "Used Capacity",
    "userExperience": 'Join in the user experience improvement project',
    "userFeedback": "Feedback",
    "userFeedbackPage": "What Happened? ",
    "UserKeyMustBeSpecified": "The Access Key ID is missing in the request.",
    "userList": "Account Management",
    "version": "Version",
    "versionUpdate": "Update Version",
    "versionWarning": "This computer program is protected by copyright law and international treaties. Unauthorized duplication or distribution of this program, or any portion of it, may result in severe civil or criminal penalties, and will be prosecuted to the maximum extent possible under the law.",
    "viewDetaile": 'View details',
    "viewPermissions": "ACL Read",
    "viewPolicyDemo": "View rule example",
    "volume": "Capacity",
    "wait": "Waiting",
    "waiting": "Waiting",
    "warning": "Warning",
    "warningHelp": "Warning",
    "website": "Website",
    "wholeBucketLifecycle": "If no prefix is specified, the lifecycle rule applies to the entire bucket.",
    "writePermissions": "Bucket Write",
    "XMLParserError": "Unknown error.",
    "year": "Year",
    "yearTooLarge": "The date and year exceeds the upper limit.",
    "yes": "Yes",
    "inputPrefix": "Enter a prefix.",
    "KeyTooLongError": "The absolute path of an object cannot exceed 1023 bytes.",
    "userSurveyStatement": "User experience improvement project",
    "info": "Information",
    "maxUploadTaskNum": "Max Number of Tasks",
    "maxUploadTaskNumWarn": "The maximum number of tasks ranges from 2 to 20.",
    "maxDownloadTaskNum": "Max Number of Download Tasks",
    "maxDownloadTaskNumWarn": "The maximum number of download tasks ranges from 5 to 50.",
    "noData": "No data available.",
    "noRecords": "No records found.",
    "general": "General",
    "network": "Network",
    "other": "Other",
    "IP": "Address",
    "Port": "Port",
    "isProxy": "Enable proxy",
    "authentication": "Authentication",
    "username": "Username",
    "password": "Password",
    "domain": "Domain:",
    "ProxyIPNotNull": "Address cannot be left blank.",
    "ProxyPortErr": "The port number must range from 0 to 65535.",
    "userOrPwdIsNull": "Username cannot be left blank.",
    "ProxyError": "Incorrect proxy username or password.",
    "407": "The proxy server is abnormal. (An internal error occurred. Status code: 407).",
    "302": "Access error. Configure the proxy and try again.",
    "304": "Documentation not modified as expected. (An internal error occurred. Status code: 304).",
    "305": "The requested resource must be accessed through the network proxy. (An internal error occurred. Status code: 305).",
    "400": "Bad request. (An internal error occurred. Status code: 400).",
    "401": "Access denied. (An internal error occurred. Status code: 401).",
    "404": "Not found. (An internal error occurred. Status code: 404).",
    "415": "Access denied. (An internal error occurred. Status code: 415).",
    "502": "Bad gateway. (An internal error occurred. Status code: 502).",
    "AllAccessDisabled": "You do not have permission to perform this operation. Contact the administrator to obtain permission.",
    "getConfigInfoErr": "Failed to obtain system configurations. Log out and log in again.",
    "serverEncryption": "Enable KMS encryption",
    "KMSEncryption": "KMS encryption",
    "Encryption": "Encryption",
    "objectAttr": "Properties",
    "EncryptionYes": "Yes",
    "EncryptionNo": "No",
    "isSureEncryption": "Are you sure you want to implement KMS encryption for the object?",
    "EncryptionSuccess": "KMS encryption succeeded.",
    "isUsedHttps": "KMS encryption does not support HTTP. Enable HTTPS.",
    "obs_term_uploadObject_encryption_tip": "Encrypts the file for secure storage. The encryption status of the encrypted file cannot be changed.",
    "obs_term_uploadObject_kmsEncryption_tip": "Uses an encryption key managed by KMS to encrypt the file that you want to upload.",
    "InvalidTargetBucketForLoggingRegion": "The bucket for logging does not exist or is not in the same region with the source bucket.",
    "AuthorizationHeaderMalformed": "Incorrect region.",
    "isSaveSK": "Remember my secret access key",
    "inputAccountNameIsRepet": "The account already exists.",
    "IllegalLocationConstraintException": "Incorrect region.",
    "ENOENT": "The path cannot be found or created. Check whether the path exists, is too long, or contains the following special characters that are not allowed in Windows systems: \\/:*?\"<>|",
    "isUpdateHasRunning": "OBS Browser cannot be upgraded, because there are running tasks. Wait until the running tasks are complete or delete all unfinished tasks, and then upgrade.",
    "selectTaskToRestart": "Select the tasks that you want to run again.",
    "selectTaskToPaused": "Select the tasks that you want to suspend.",
    "selectTaskToCancel": "Select the tasks that you want to cancel.",
    "copyright_HEC": "Copyright © Huawei Technologies Co., Ltd. " + (new Date().getFullYear()) + ". All rights reserved.",
    "copyright_YLM": "Copyright © Huawei Technologies Co., Ltd. " + (new Date().getFullYear()) + ". All rights reserved.",
    "copyright_DT": "Copyright © " + (new Date().getFullYear()) + " T-Systems International GmbH. All rights reserved.",
    "DtProduct": "OBS Browser is part of OTC.",
    "accessKeyPlaceholder": "Access Key ID",
    "secretKeyPlaceholder": "Secret Access Key",
    "ServiceUnavailable": "The service is unavailable.",
    "selectDeleteObject1": "Some tasks associated with selected objects are not completed or failed. Wait until the tasks are completed or delete those tasks and retry.",
    "deleteBucketErrMessage": "Cannot determine whether the bucket has objects or fragments. Check whether you have the read permission for this bucket.",
    "open": "Open",
    "menu_configure": "Configure",
    "menu_other": "Other",
    "bucketSearchInfo": "Enter a bucket name.",
    "copySuccess": "URL copied successfully.",
    "setting": "Settings",
    "loggingConfigStat": "Log Management",
    "bucketNameInTable": "Bucket Name",
    "userSurveyStatementMsg":"Dear User,<br><br>Thank you for choosing HUAWEI CLOUD’s OBS Browser. Please make sure you have carefully read and thoroughly understand the following content provided in this Policy before you decide to participate in the User Experience Improvement Project of OBS Browser. Your participation in this project shall be deemed as the consent and acknowledgement of the entirety of this Policy.<br><br>User shall understand and agree to all the following provisions with respect to the User Experience Improvement Project of OBS Browser: <br><br>1.	When you participate in the User Experience Improvement Project of OBS Browser, data such as your OBS Browser configuration data, application statistics, program error log, and user behavior data of using the HUAWEI CLOUD OBS will be collected and a small amount of network traffic will be producted.<br>2. The collected data will be anonymized and encrypted before being transferred to Huawei. We will statistically analyze all the transferred data in order to improve our products and services as well as the user experience of OBS Browser. In the process of the foregoing data processing, the collected data cannot be characterized or related to an identified or identifiable natural person.<br>3. It is probable that the collected data will be used to some personalized products, the purpose of which is to promote user experience and services. In addition, Huawei may disclose some relevant synopsis data an diagnostic data to our partners and third parties to improve the dedicated applications, products and services developed and supplied by them, and then the responsibility to protect the foregoing data will be borne by them. Furthermore, Huawei may disclose the collected data by observing applicable laws, legal procedures, and litigation or by the request of the authorities such as public or administrative departments.<br>4.You can choose to participate in or quit the User Experience Improvement Project at any time to allow or prevent the collection and transfer of the collected data manually from \"System Configuration\".<br>5. The collected data will be stored in Huawei’s servers properly and carefully and will not be disclosed, spread and utilized to any other products which do not belong to Huawei.<br>6. The collected data will be stored until the statistical analysis of the collected data has been finished, and then the collected data will be destroyed completely.<br>7.	Huawei shall not liable for the collection or disclosure of the collected data by and third party through any other application or procedure. <br><br>For more information, please read our <a class='privacyPlicy' href='http://www.huaweicloud.com/en-us/declaration/sa_prp.html'>Privacy Policy</a>.",
    "cancelRunningTasksMsg":"There are ongoing tasks. Are you sure you want to cancel them?",
    "cancelRunningTaskMsg":"The specified task is running. Are you sure you want to cancel it?",
    "lifeCycleExpireRange": "The value of Expires in must range from 1 to 999999.",
    "editLifecycleRule": "Edit Lifecycle Rule",
    "editCorsRule": "Edit CORS Rule",
    "allowedAriginError":"In Allowed Origin, each line contains a maximum of one asterisk (*).",
    "allowedHeaderError":"The value of Allowed Header is invalid.",
    "exposeHeaderError":"The value of Exposed Header is invalid.",
    "FolderAlreadyExists": "The folder already exists.",
    "selectNotExtBucket": "Select a non-external bucket.",
    "selectBucketTips": "Select a bucket.",
    "selectFile": "Select a file.",
    "selectFileOrFolder": "Select one or more files or folders.",
    "selectRule": "Select a rule to edit.",
    "selectRules": "Select at least one rule to delete.",
    "taskShowSizeMin":"The task list must show a minimum of 50 tasks.",
    "taskShowSizeMax":"The task list can show a maximum of 150 tasks.",
    "taskShowSizeTitle":"Task Count in Task List",
    "objListPerPageMin":"The object list must show a minimum of 50 objects on each page.",
    "objListPerPageMax":"The object list can show a maximum of 150 objects on each page.",
    "objListPerPageTitle":"Number of Objects Displayed on Each Page",
    "uploadOverwriteTip":"Uploading will overwrite the existing object with the same name.",
    "addLifecycleTips":"Delete the rule or configure it by prefix.",
    "targetVersion":"Target Version  ",
    "defaultKMSKeyInit":"In a region that supports KMS encryption, OBS will use a default KMS key. If there is no default key, OBS will automatically create one. Are you sure you want to continue?",
    "dateOfLastUpdate": "Released  ",
    "copyright_OCB": "@Orange Business Services " + (new Date().getFullYear()),
    "copyright_TLF": "",
    "warn_delete_single_record":"The deleted record cannot be recovered. Are you sure you want to continue?",
    "warn_delete_selected_record":"The deleted records cannot be recovered. Are you sure you want to continue?",
    "warn_delete_all_record":"All records of the current type will be deleted and cannot be recovered. Are you sure you want to continue?",
    "obs_term_storageClass_lable":"Storage Class",
    "obs_task_createMethod_lable":"Method",
    "obs_term_region_column":"Region",
    "obs_term_completed_tab":"Completed",
    "obs_term_deleteAll_button":"Delete All",
    "obs_task_createBucket_radio":"Create new bucket",
    "obs_task_createAddExternalBucket_radio":"Add external bucket",
    "obs_term_standard_lable":"Standard",
    "obs_term_nearline_lable":"Warm",
    "obs_term_coldline_lable":"Cold",
    "obs_term_nearline_lable_HEC":"Infrequent Access",
    "obs_term_coldline_lable_HEC":"Archive",
    "obs_term_changeStorageClass_changBucket_msg": "Changing the storage class of a bucket does not change the storage class of objects in the bucket. To manage the storage class of existing objects, lifecycle rules are recommended.",
    "obs_term_standard_tip":"Optimized for frequently accessed (multiple times per month) data such as small and essential files that require low latency.",
    "obs_term_nearline_tip":"Optimized for infrequently accessed (once per month) data that requires low latency.",
    "obs_term_coldline_tip":"Optimized for rarely accessed (once per year) data.",
    "obs_term_changeStorageClass_coldObejctNotRestore_tip": "If the storage class of a bucket is changed from Cold to Standard or Warm, objects in the bucket are not automatically restored.",
    "obs_term_changeStorageClass_archiveObejctNotRestore_tip": "If the storage class of a bucket is changed from Archive to Standard or Infrequent Access, objects in the bucket are not automatically restored.",
    "obs_task_restoreObjectExpedited_radio":"Expedited",
    "obs_task_restoreObjectStandard_radio":"Standard",
    "obs_task_restoreObjectBulk_radio":"Bulk",
    "obs_term_restore_button":"Restore",
    "obs_term_taskForRemainingTime_tip": "The Remaining Time is not displayed for Restoring tasks and tasks that are finished instantly.",
    "obs_term_taskForSpeed_tip": "The Speed is not displayed for Restoring tasks and tasks that are finished instantly.",
    "obs_task_restoreObject_restoreOnlyCold_tip" : "Select at least one object to restore. Only objects in the Cold storage class can be restored.",
    "obs_task_restoreObject_restoreOnlyArchive_tip" : "Select at least one object to restore. Only objects in the Archive storage class can be restored.",
    "obs_task_restoreObjectExpedited_tip":"Restores the objects within 1 to 5 minutes.",
    "obs_task_restoreObjectStandard_tip":"Restores the objects within 3 to 5 hours.",
    "obs_task_restoreObjectBulk_tip":"Restores the objects within 5 to 12 hours.",
    "obs_term_integerRange_tip":"Enter a positive integer equal to or greater than {0}.",
    "obs_term_bucketLifecycle_ruleMaxDays_tip": "Enter a numeral that is equal to or less than {0}.",
    "obs_term_bucketLifecycle_enterPrefix_tip": "Enter an object name prefix. If no prefix is specified, the lifecycle rule will apply to the entire bucket.",
    "obs_term_bucketLifecycle_prefix_valid": "The object name prefix contains a maximum of 1023 characters.",
    "obs_term_bucketLifecycle_rule4_valid": "The lifecycle rule name contains a maximum of 255 characters.",
    "obs_task_refreshRestoreTaskFail_info":"Failed to refresh restoration tasks.",
    "obs_term_restored_lable":"Restored",
    "obs_term_restoring_lable":"Restoring",
    "obs_term_notRestored_lable":"Unrestored",
    "obs_term_expirationTime_lable":"Expires",
    "obs_task_restoreObject_wintitle":"Restore Object",
    "obs_term_bucket_lable":"Bucket",
    "obs_task_restoreObjectValidityPeriod_lable":"Validity Period",
    "obs_task_restoreObjectSpeed_lable":"Speed",
    "obs_term_taskName_column":"Task Name",
    "obs_term_restoredTime_lable":"Restored:",
    "obs_task_restoreSuccess_info":"Restoration task issued successfully.",
    "obs_task_restoreValidityPeriodFault_info":"The end time of the new validity period must be later than that of the old validity period.",
    "obs_task_restoreUnavailable_tip" : "The object is being restored. No need to repeat the operation.",
    "obs_task_downloadUnavailable_tip" : "This operation cannot be performed because the object is unrestored or restoring.",
    "obs_task_createAddColdlineExternalBucket_info" : "The selected external bucket is a cold bucket and cannot be added.",
    "obs_task_viewEncryptionDeny_tip" : "You do not have permissions to obtain the object encryption status.",
    "obs_term_status_lable" : "Restoration Status",
    "ObjectHasAlreadyRestored":"The end time of the new validity period must be later than that of the old validity period.",
    "obs_term_characterLimit_info":"{0} cannot exceed {1} characters.",
    "obs_term_success_label":"Succeeded",
    "obs_term_allType_list":"All types",
    "obs_task_runAllTask_tip":"All tasks have been added to the running queue.",
    "obs_task_deleteObject_wintitle":"Delete Object",
    "obs_term_tasksTotal_msg":"Total",
    "obs_term_tasksUncompleted_msg":"Uncompleted",
    "obs_term_acl_logUser_tip": "If a bucket is selected for saving logs, the log delivery user is automatically granted the permissions to read the bucket ACL and write logs to the bucket. If you disable such permissions, log files will fail to be generated.",
    "obs_term_acl_anonymousUser_tip": "An anonymous user can be anyone, either registered or unregistered.",
    "obs_term_acl_registeredUser_tip": "The registered user group refers to all users who have registered with the cloud service. Access requests from a registered user group must pass identity authentication before obtaining the access permission.",
    "obs_task_addLifecycleFail_prefixOverlap_msg":"The prefix of the newly added or modified rule contains or is contained in the prefix of an existing rule.",
    "obs_term_moveObject_button":"Move",
    "obs_term_copyObject_button":"Copy",
    "obs_term_pasteObject_button":"Paste",
    "obs_term_moveOrCopyObject_tip":"Click Move or Copy and go to another bucket or directory in the current region to paste data.",
    "obs_term_moveObject_msg":"Moving an object will remove it from its original path, and overwrite the namesake object in the destination path. Are you sure you want to continue?",
    "obs_term_moveObject_tip":"Note: If you move an object to another place, the object will be removed from its original place.",
    "obs_term_proxyAddress_valid" : "Incorrect address format. The proxy address can only be a domain name or an IP address. For example: proxy.example.com ",
    "obs_term_proxyAddress_valid1" : "Incorrect address format. The proxy address can only be a domain name or an IP address. For example: proxy.example.com:8080 ",
    "obs_task_pasteObjectFail_msg":"{0} The copy object could not be created.",
    "obs_task_pasteObjectSuccess_setAclFail_msg":"{0} The copy object was created successfully, but the permission of the copy object could not be set. If you move the object, the original object will be retained. Check whether the permission of the copy object is consistent with that of the original object.",
    "obs_task_pasteObjectSuccess_delSourceobjectFail_msg":"{0} The copy object was created successfully, but the original object could not be deleted.",
    "obs_task_pasteObjectSuccess_getTargetObjectInfoFail_msg":"{0} The copy object was created successfully, but information about the copy object could not be obtained temporarily. The deletion of the original object is terminated.",
    "obs_task_pasteObjectSuccess_getSourceObjectAclFail_msg":"{0} The permission of the original object could not be obtained.",
    "obs_quit_check_move_task_confirm":"Move tasks are being executed and cannot be suspended. These tasks may fail if you forcibly exit the program. Exit now?",
    "obs_switchUser_check_move_task_confirm":"Move tasks are being executed and cannot be suspended. These tasks may fail if you switch accounts. Switch now?",
    //OBS Browser业务错误码，对用户可见，2017-01-10 优化
    "ERR_CODE_407":"Unauthorized gateway or proxy server. Enter the correct authentication information.",
    "ERR_CODE_500":"Internal server error. Contact the customer service.",
    "ERR_CODE_501":"This function is not supported currently.",
    "ERR_CODE_502":"Bad gateway or unable to connect to the proxy server. Contact the customer service.",
    "ERR_CODE_503":"The server is busy. Try again later.",
    "ERR_CODE_AccessDenied":"You do not have permission to perform this operation. Contact the administrator to obtain permission.",
    "ERR_CODE_AccountProblem":"Your account expires or is frozen. The operation cannot be performed.",
    "ERR_CODE_AmbiguousGrantByEmailAddress":"Internal server error. Contact the customer service.",
    "ERR_CODE_BadDigest":"Internal server error. Contact the customer service.",
    "ERR_CODE_BucketAlreadyExists":"The requested bucket name already exists. Bucket namespace is shared by all users in the system. Select a different name and retry.",
    "ERR_CODE_BucketNotEmpty":"The bucket {0} cannot be deleted because it is not empty. To delete the bucket, you have to delete all objects and fragments in the bucket, and then log in to OBS Console to delete all objects from the list of Deleted Objects.",
    "ERR_CODE_CredentialsNotSupported":"Internal server error. Contact the customer service.",
    "ERR_CODE_EBADF":"Access to the local file denied. Please retry.",
    "ERR_CODE_EBUSY":"Failed to upload the target file because it has been occupied. Check whether the file is accessible.",
    "ERR_CODE_EISDIR":"Failed to read the file. Please retry.",
    "ERR_CODE_ENOENT4058":"The path cannot be found or created. Check whether the path exists, is too long, or contains the following special characters that are not allowed in Windows systems: \\/:*?\"<>|",
    "ERR_CODE_ENOSPC":"Insufficient local disk space. Delete unnecessary files to ensure that the disk space is sufficient.",
    "ERR_CODE_EntityTooLarge":"The submitted content exceeds the upper limit.",
    "ERR_CODE_EntityTooSmall":"Internal server error. Contact the customer service.",
    "ERR_CODE_EPERM":"You do not have permission to read or write a local file. Apply for the required permissions.",
    "ERR_CODE_InArrearOrInsufficientBalance":"The account balance is overdue or insufficient. Please recharge and retry.",
    "ERR_CODE_IncompleteBody":"Internal server error. Contact the customer service.",
    "ERR_CODE_IncorrectNumberOfFilesInPostRequest":"Internal server error. Contact the customer service.",
    "ERR_CODE_InlineDataTooLarge":"Internal server error. Contact the customer service.",
    "ERR_CODE_InternalError":"Internal server error. Contact the customer service.",
    "ERR_CODE_InvalidAccessKeyId":"You cannot log in to OBS Browser due to failure in account authentication. The AK/SK of the account may be input incorrectly, expired, or deleted. Check and try again.",
    "ERR_CODE_InvalidArgument":"Invalid parameter.",
    "ERR_CODE_InvalidDigest":"Internal server error. Contact the customer service.",
    "ERR_CODE_InvalidLocationConstraint":"Incorrect region.",
    "ERR_CODE_InvalidPart":"Failed to upload the file in multiparts. Delete this task and retry.",
    "ERR_CODE_InvalidPartOrder":"Failed to upload the file in multiparts. Delete this task and retry.",
    "ERR_CODE_InvalidPayer":"All access requests to this object are invalid. Contact the customer service.",
    "ERR_CODE_InvalidPolicyDocument":"The content of the form does not meet the conditions specified in the policy document.",
    "ERR_CODE_InvalidRange":"Failed to download the file. Try again later.",
    "ERR_CODE_InvalidRedirectLocation":"Internal server error. Contact the customer service.",
    "ERR_CODE_InvalidRequest":"Internal server error. Contact the customer service.",
    "ERR_CODE_InvalidTargetBucketForLogging":"This operation cannot be performed because:<br/>- The bucket for logging does not exist.<br/>- The bucket for logging does not belong to you.<br/>- You do not have the required permission. For this reason, ensure that the log delivery user has the Write and ACL View permissions for the bucket where logs are saved. Configure the permissions in the Configure Bucket ACL dialog box.",
    "ERR_CODE_KeyTooLong":"The absolute path of an object cannot exceed 1023 bytes.",
    "ERR_CODE_MalformedPOSTRequest":"Internal server error. Contact the customer service.",
    "ERR_CODE_MalformedXML":"Internal server error.Contact the customer service.",
    "ERR_CODE_MaxMessageLengthExceeded":"Internal server error. Contact the customer service.",
    "ERR_CODE_MaxPostPreDataLengthExceededError":"Internal server error. Contact the customer service.",
    "ERR_CODE_MetadataTooLarge":"Internal server error. Contact the customer service.",
    "ERR_CODE_MethodNotAllowed":"Internal client error. Contact the customer service.",
    "ERR_CODE_MissingContentLength":"Internal server error. Contact the customer service.",
    "ERR_CODE_MissingRequestBodyError":"Internal client error. Contact the customer service.",
    "ERR_CODE_MissingRequiredParameter":"Internal client error. Contact the customer service.",
    "ERR_CODE_MissingSecurityHeader":"Internal client error. Contact the customer service.",
    "ERR_CODE_NetworkingError":"Network unreachable or invalid domain name. Please check your connection settings.",
    "ERR_CODE_NetworkingError1":"The connection timed out. Try again later.",
    "ERR_CODE_NetworkingError2":"Network unreachable or invalid domain name. Please check your connection settings.",
    "ERR_CODE_NoSuchBucket":"The specified bucket does not exist.",
    "ERR_CODE_NoSuchFile":"The file or folder does not exist.",
    "ERR_CODE_NoSuchKey":"The object does not exist.",
    "ERR_CODE_NoSuchUpload":"The specified upload does not exist. The upload ID may be invalid, or the upload may have been aborted or completed.",
    "ERR_CODE_NoSuchVersion":"Failed to obtain the file of the specified version.",
    "ERR_CODE_NotImplemented":"This function is unavailable now.",
    "ERR_CODE_OperationAborted":"Your operation is conflicting with another user's operation. Try again later.",
    "ERR_CODE_PermanentRedirect":"The bucket that you attempt to access is not found in this region. Select another bucket.",
    "ERR_CODE_RegionNameNotMatch":"Incorrect region. Enter a correct region.",
    "ERR_CODE_RequestTimeout":"The request timed out. Try again later.",
    "ERR_CODE_RequestTimeTooSkewed":"Time difference is longer than 15 minutes between the client and server. Adjust the local time.",
    "ERR_CODE_SignatureDoesNotMatch":"Incorrect Access Key ID or Secret Access Key.",
    "ERR_CODE_SlowDown":"The server's load is too heavy. Try again later.",
    "ERR_CODE_someObjectDelErr":"Some objects could not be added to the deletion queue. Try to add these objects again.",
    "ERR_CODE_someObjectDownErr":"Some objects could not be added to the download queue. Try to add these objects again.",
    "ERR_CODE_TooManyBuckets":"The number of buckets has reached the upper limit. Delete unnecessary buckets before creating new ones.",
    "ERR_CODE_TooManyWrongSignature":"The current account has been locked. Retry after 15 minutes.",
    "ERR_CODE_undefinedError":"Failed to process the request. Please retry.",
    "ERR_CODE_UnknownEndpoint":"Network unreachable or invalid domain name. Please check your connection settings.",
    "ERR_CODE_XMLParserError":"Internal server error. Contact the customer service.",
    "ERR_CODE_KeyTooLongError":"The absolute path of an object cannot exceed 1023 bytes.",
    "ERR_CODE_ProxyError":"Unable to connect to the proxy server. Check whether the network is normal and the authentication information about the proxy server is correct.",
    "ERR_CODE_AllAccessDisabled":"You do not have permission to perform this operation. Contact the administrator to obtain permission.",
    "ERR_CODE_InvalidTargetBucketForLoggingRegion":"The bucket for logging does not exist or is not in the same region with the source bucket.",
    "ERR_CODE_AuthorizationHeaderMalformed":"Incorrect signature. Contact the customer service.",
    "ERR_CODE_IllegalLocationConstraintException":"Incorrect region. Change the region and retry.",
    "ERR_CODE_ENOENT":"The path cannot be found or created. Check whether the path exists, is too long, or contains the following special characters that are not allowed in Windows systems: \\/:*?\"<>|",
    "ERR_CODE_ServiceUnavailable":"The server's load is too heavy. Try again later.",
    "ERR_CODE_searchPrefixTooLong":"The absolute path in the search criteria exceeds 1023 bytes.",
    "ERR_CODE_RestoreAlreadyInProgress":"The object is being restored. No need to repeat the operation.",
    "ERR_CODE_InvalidObjectState":"The specified object does not support the operation.",
    "ERR_CODE_NotFound":"The specified bucket cannot be found.",
    "ERR_CODE_Forbidden":"The current user does not have permissions to perform this operation.",
    "ERR_CODE_InvalidDefaultStorageClass":"Invalid storage class. OBS supports Standard, Warm, and Cold only.",
    "ERR_CODE_BucketStoragePolicyConflict":"A storage policy has been configured for the specified bucket.",
    "ERR_CODE_lifecycle_duplicate_ruleid":"Rule name must be unique. Found same name for more than one rule.",
    "ERR_CODE_FsNotSupport" : "This operation cannot be performed because this bucket is belong to parallel file system.",
    "KMS.KMSInvalidStateException": "The KMS key is in the Scheduled deletion state. Go to KMS to cancel the deletion.",
    "DeregisterUserId": "The reservation period of user resources has exceeded the threshold. Services are unavailable.",
    "obs_term_uploadObject_addFile_tip": "Select the object that you want to upload first.",
    "obs_term_uploadObject_addFolder_tip": "Select the folder that you want to upload first.",
    "obs_term_uploadObject_addFile_button": "Select File",
    "obs_term_uploadObject_addFolder_button": "Select Folder",
    "obs_term_uploadObject_uploadObject_wintitle": "Upload Object",
    "obs_term_uploadObject_files_lable": "Files",
    "obs_term_uploadObject_objects_lable": "Objects",
    "obs_term_uploadObject_localPath_cloumn": "Local Path",
    "obs_term_uploadObject_localNotExist_msg": "Files or Folders displayed in red indicate that they do not exist in the local path. Remove them before uploading.",
    "obs_term_bucketLifecycle_currentExpires_radio": "Current Version",
    "obs_term_bucketLifecycle_historicalExpires_radio": "Historical Version",
    "obs_term_bucketLifecycle_historicalExpires_tip": "Lifecycle rules can take effect on historical versions of objects only when versioning is enabled for the bucket.",
    "obs_term_bucketLifecycle_expiresWarn_tip": "Note: Because versioning is not enabled for the current bucket, objects will be permanently deleted upon expiration.",
    "obs_term_bucketLifecycle_expires_lable": "Expiration Time",
    "obs_term_bucketLifecycle_notConfig_radio": "Do not configure",
    "obs_term_bucketLifecycle_expiresByDay_radio": "Configure now",
    "common_term_changeStorageClass_button": "Change Storage Class",
    "obs_term_bucketLifecycle_changesIn_lable": "Transition After",
    "obs_term_bucketLifecycle_noExpires_msg": "Set the expiration time of the current version and historical versions.",
    "obs_term_downloadObject_sameFileName_wintitle": "Duplicate File Name",
    "obs_term_downloadObject_sameFileName_msg": "Files with the same name exist in the target directory. Select a saving method.",
    "obs_term_downloadObject_sameFileName_keepAll_btn": "Keep All",
    "obs_term_downloadObject_sameFileName_overWrite_btn": "Overwrite",
    "obs_term_bucketLifecycle_change2Warm_lable": "Transition to Warm",
    "obs_term_bucketLifecycle_change2Cold_lable": "Transition to Cold",
    "obs_term_bucketLifecycle_dayRule_info": "If Transition to Warm, Transition to Cold, and Expiration Time are configured by day, the following requirements must be met: Expiration Time > Transition to Cold > Transition to Warm.",
    "obs_term_bucketLifecycle_prefixContainsSpecial_valid": "Object name prefix naming rules:<br/>- Cannot contain the following special characters: \\:*?\"<>|<br/>- Cannot start with a slash (/) <br/>- Cannot have two consecutive slashes (/)",
    "obs_term_bucketLifecycle_expiresDays_lable":"Delete After",
    "obs_term_createFolder_ruler1_valid":"- The absolute path of the folder cannot exceed 1023 characters.",
    "obs_term_addBucket_button":"Add Bucket",
    "obs_term_unlinkBucket_button":"Unmount",
    "obs_term_unlinkBucket_Wintitle":"Unmount External Bucket",
    "obs_term_unlinkBucket_msg":"Are you sure you want to unmount the following external buckets?",
    "obs_term_unlinkBucket_warn_msg":"Unmounting will not affect existing data in the external bucket. However, you need to mount the external bucket again if you want to access it later.",
    "obs_term_unlinkBucket_unlinkSuccess_msg":"External bucket {0} unmounted successfully.",
    "obs_term_object_objectRestore_column":"Restore",
    "obs_term_bucketLifecycle_hecDayRule_info":"If Transition to Infrequent Access, Transition to Archive, and Expiration Time are configured by day, the following requirements must be met: Expiration Time > Transition to Archive > Transition to Infrequent Access.",
    "obs_term_bucketLifecycle_change2Archive_lable":"Transition to Archive",
    "obs_term_bucketLifecycle_change2Infrequent_lable":"Transition to Infrequent Access",
    "obs_term_bucketLifecycle_transitioned2Infrequent_lable": "Transitioned to Infrequent Access after",
    "obs_term_bucketLifecycle_transitioned2Archive_lable": "Transitioned to Archive after",
    "obs_term_bucketLifecycle_transitioned2Warm_lable": "Transitioned to Warm after",
    "obs_term_bucketLifecycle_transitioned2Cold_lable": "Transitioned to Cold after",
    "obs_term_verfiyCertificate_label" : "Enable certificate verification",
    "obs_term_verfiyCertificate_tip" : "(recommended for data security)",
    "obs_term_certificateNotValid_msg" : "Certificate verification failed.",
    "obs_term_md5Check":"Enable MD5 verification",
    "obs_term_md5Checking":"Verifying MD5",
    "obs_term_md5CheckTips":"(Enabling MD5 verification will affect upload and download speeds.)",
    "obs_term_changeStorageClass_bucketSuccess_msg": "Storage class of bucket {0} changed successfully.",
    "obs_term_changeStorageClass_objectSuccess_msg": "Storage class of object {0} changed successfully.",
    "obs_task_changeStorageClassUnavailable_tip": "This operation cannot be performed because the object is unrestored or restoring.",
    "obs_term_createFolder_nameRule_lable": "Naming rules:",
    "obs_term_bucketLifecycle_transition2Warm_tip":"After this number of days since the last update, objects of the current version will be transitioned to Warm storage. The transition time must be at least 30 days later.",
    "obs_term_bucketLifecycle_transition2Archive_tip": "After this number of days since the last update, objects of the current version will be transitioned to Archive storage. This value must be at least 30 days later than the date configured for Transition to Infrequent Access.",
    "obs_term_bucketLifecycle_expiresWithTrans_tip": "After this number of days since the last update, objects of the current version will be deleted. If configured, this value must be longer than any of the configured transition times.",
    "obs_term_bucketLifecycle_transition2Infrequent_tip": "After this number of days since the last update, objects of the current version will be transitioned to Infrequent Access storage. The transition time must be at least 30 days later.",
    "obs_term_bucketLifecycle_transition2Cold_tip": "After this number of days since the last update, objects of the current version will be transitioned to Cold storage. This value must be at least 30 days later than the date configured for Transition to Warm.",
    "obs_term_bucketLifecycle_currentObjectWithTrans_tip": "Objects of the current version that meet the rule conditions will be transitioned to a specified storage class or deleted automatically after a specified number of days.",
    "obs_term_bucketLifecycle_currentObject_tip": "Objects of the current version that meet the rule conditions will be deleted automatically after a specified number of days.",
    "obs_term_bucketLifecycle_historyObjectWithTrans_tip": "Objects of historical versions that meet the rule conditions will be transitioned to a specified storage class or deleted automatically after a specified number of days.",
    "obs_term_bucketLifecycle_historyObject_tip": "Objects of historical versions that meet the rule conditions will be deleted automatically after a specified number of days.",
    "obs_term_bucketLifecycle_delMultiLifecycle_msg": "Are you sure you want to delete the selected {0} lifecycle rules?",
    "obs_term_delMultiCorsRule_msg": "Are you sure you want to delete the selected {0} CORS rules?",
    "obs_term_restoreObject_validityPeriod_tip": "The duration for which an object remains in the Restored state after restoration.",
    "obs_term_bucketLogging_targetPrefix_tip": "The prefix of the log file name. If the prefix ends with a forward slash (/), logs generated are stored in the <i>TargetPrefix</i> folder. If no prefix is specified, the log files are stored as objects in the bucket.",
    "obs_term_bucketLogging_targetBucket_tip": "Stores log files that are generated after logging has been enabled.",
    "obs_term_proxyAddressLength_valid": "Enter a maximum of 255 characters.",
    "obs_term_proxyUserLength_valid": "Enter a maximum of 255 characters.",
    "obs_task_createBucket_needAuthentication_msg": "Cloud services require real-name authentication. Click <a id=\"toAuth\">here</a> to complete real-name authentication.",
    "obs_object_prefix":"Do not enter any slash (/).",
    "ObjAclDescription":"You can manage permissions for operations on objects by configuring object ACLs.",
    "obs_mongodbUI":"The task management function cannot work properly because the database is unavailable. Shut down OBS Browser, delete all files in the obs folder in the database path (check the path at System Configurations > Others), and restart OBS Browser.",
    "obs_mongodbAbnormal_msg":"Database exception. Restart OBS Browser.",
    "fileName":"File Name",
    "obs_term_bucketLogging_disable_tip": "Access logs will no longer be written to the bucket where logs are saved. However, existing logs are retained and permissions granted to the log delivery user remain unchanged.",
    "obs_term_bucketLogging_enable_tip":"The log delivery user will be automatically granted permissions to read the ACL of the bucket where logs are to be saved and write logs to the bucket.",
    "obs_term_bucketLifecycle_learnMore_info": "You can create lifecycle rules to automatically delete objects that meet specified conditions.",
    "obs_term_deleteBucket_tips":"Deleted data cannot be recovered. Exercise caution when performing this operation.",
    "obs_term_delFolder_disableVersion_tip": "- If versioning is disabled, the selected folder or folders and files included will be permanently deleted.",
    "obs_term_delFolder_enableVersion_tip": "- If versioning is enabled, the selected folder or folders and files included will be removed and stored in the list of Deleted Objects on the Objects page of OBS Console. You can log in to OBS Console and cancel the deletion for files in a folder to restore the folder as needed.",
    "common_term_emptyEnter_msg": "This field cannot be left blank.",
    "obs_term_createBucket_ruler0_valid": "Contains 3 to 63 characters",
    "obs_term_createBucket_ruler1_valid": "Can contain only lowercase letters, digits, hyphens (-), and periods (.)",
    "obs_term_createBucket_ruler2_valid": "Cannot be an IP address",
    "obs_term_createBucket_ruler3_valid": "Cannot start or end with a hyphen (-) or period (.)",
    "obs_term_createBucket_ruler4_valid": "Cannot contain two consecutive periods (.)",
    "obs_term_createBucket_ruler5_valid": "Cannot contain periods (.) and hyphens (-) adjacent to each other",
    "obs_term_ObjectTips":"The total number of folders and files, including all versions.",
    "obs_term_NoAccount":"The account does not exist.",
    "obs_objectPolicy_button": "Configure Object Policy",
    "obs_objectPolicy_wintitle": "Configure Object Policy",
    "obs_objectPolicy_object_lable": "Object",
    "obs_objectPolicy_info": "An object policy authorizes an IAM user the permission to access the object.",
    "obs_objectPolicy_create_button": "Create Object Policy",
    "obs_objectPolicy_edit_button": "Edit Object Policy",
    "obs_objectPolicy_user_lable": "Authorized User",
    "obs_objectPolicy_permission_lable": "Permission",
    "obs_objectPolicy_user_hint": "Select a user.",
    "obs_objectPolicy_read_tip": "The authorized user has the permission to read the object.",
    "obs_objectPolicy_readAndWrite_tip":"The authorized user has the permission to read and delete the object.",
    "obs_objectPolicy_read_option": "Read only",
    "obs_objectPolicy_readAndWrite_option": "Read and write",
    "obs_objectPolicy_userLimit_tip": "An object policy can authorize only one user the access permission.",
    "obs_objectPolicy_createSuccess_msg": "Object policy configured successfully.",
    "obs_objectPolicy_editSuccess_msg": "Object policy edited successfully.",
    "obs_objectPolicy_delSuccess_msg": "Object policy deleted successfully.",
    "obs_objectPolicy_delMultiSuccess_msg": "{0} object policies deleted successfully.",
    "obs_objectPolicy_del_winTitle": "Delete Object Policy",
    "obs_objectPolicy_del_msg": "Are you sure you want to delete the following policy?",
    "obs_objectPolicy_delMulti_msg": "Are you sure you want to delete the following {0} policies?",
    "obs_objectPolicy_delWarn_msg": "Deleted policies cannot be recovered. Exercise caution when performing this operation.",
    "obs_objectPolicy_createRepeat_msg": "User {0} cannot be authorized because the user has already been authorized by an existing policy.",
    "obs_objectPolicy_onlySelOne_tip": "Select the object you want to configure.",
    "obs_objectPolicy_accountID_lable": "Account ID:",
    "obs_objectPolicy_accountID_hint": "Enter the current account ID.",
    "obs_objectPolicy_createNoID_tip": "This operation can be performed only when the account ID is entered.",
    "obs_objectPolicy_accountIDError_msg": "Invalid account ID or you do not have the permission to query the account ID. Enter another account ID or switch to another account and try again.",
    "obs_objectPolicy_accountID_tip":"To ensure information security, OBS Browser requires your account ID for identity authentication. You can <a id=\"toIamAddNewAccountKnowMore\">log in to the console</a> and select My Credential from the drop-down list of the username to view your account ID.",
    "obs_objectPolicy_copyObjectSuccess_msg": "Object path copied successfully.",
    "obs_deleteBucket_tips":"The following bucket cannot be deleted because it is not empty. To delete the bucket, you have to delete all objects in the bucket, and then log in to OBS Console to delete all objects from the list of Deleted Objects.",
    "lastUpdateDate":"Date of last update: ",
    "obs_term_renameObject_button": "Rename",
    "obs_term_renameObject_wintitle": "Rename Object",
    "obs_term_renameObject_lable": "New Name",
    "obs_term_renameObject_placeholder": "Enter a name for the object.",
    "obs_term_renameObject_nameSame_msg": "The object name already exists in the current path. Try another one.",
    "obs_term_renameObject_nameNull_msg": "This field cannot be left blank.",
    "obs_term_renameObject_valid_0001":"An object name cannot contain slashes (/). Please enter again.",
    "obs_term_pasteObject_msg": "An object with the same name {0} already exists in the current path. If you continue to paste the object, it will replace the original one. If you need to keep the original object, rename the object to be pasted.",
    "obs_term_pasteMultiObject_msg": "The paste operation will overwrite existing objects with the same names in the current path. Are you sure you want to continue?",
    "obs_term_pasteObject_tip": "This operation can be performed only when objects are copied or selected to move.",
    "obs_browser_path_placeholder": "Enter the bucket name or object path.",
    "obs_browser_path_valid": "Invalid bucket name or object path. Try another one.",
    "obs_browser_path_lable": "Access Path",
    "obs_browser_path_hint": "Enter access path.",
    "obs_browser_path_tip": "You can enter the bucket name or object path to view the specified bucket or object.",
    "obs_browser_endpoint_lable": "Endpoint",
    "obs_browser_endpoint_tip": "To facilitate access to resources, an endpoint is provided for each region.",
    "obs_browser_accessDomain_lable": "Access Domain Name",
    "obs_browser_accessDomain_tip": "The internet address of the bucket. The bucket can be directly accessed through the domain name for purposes such as cloud application development and data sharing.",
    "obs_browser_lifecycle_basic_lable": "Basic Information",
    "obs_browser_selectObjectsDel_tip": "Select at least one object to delete.",
    "obs_browser_setDBPath_lable": "Database Path",
    "obs_browser_setDBPath_hint": "Enter the database path.",
    "obs_browser_setDBPath_valid": "The database path cannot contain Chinese characters.",
    "obs_browser_setDBPath_msg": "The path where task management data is stored. The path cannot contain any Chinese character, which may cause failures in writing the task management data to the database. If Chinese characters are contained, modify the path first and then restart OBS Browser to make the path valid.",
    "obs_browser_download_wintitle": "Download Folder",
    "obs_browser_downloadPath_lable": "Path",
    "obs_browser_downloadPath_hint": "Select a path.",
    "obs_browser_downloadConfig_lable": "Options",
    "obs_browser_downloadRestore_lable": "Restore and download",
    "obs_browser_downloadRestoreArchive_tip": "Archive files must be restored before they can be downloaded.",
    "obs_browser_downloadRestoreCold_tip": "Cold files must be restored before they can be downloaded.",
    "obs_browser_uploadCompleted_lable": "After Upload",
    "obs_browser_uploadCompleted_moveFile_options": "Move source data to the following path",
    "obs_browser_uploadCompleted_moveFolder_options": "Move source folders to the following path",
    "obs_browser_uploadCompleted_move_hint": "Select a path.",
    "obs_browser_bucketVersion_lable": "Bucket Version",
    "obs_browser_delTask_wintitle": "Delete Task",
    "obs_browser_removeFile":"Remove",
    "obs_browser_removeAllFile":"Remove All",
    "obs_browser_removeAllFile_msg":"Are you sure you want to remove all files and folders?",
    "obs_term_domainName_CNAMEHelp_link": "About CNAME configuration",
    "obs_term_domainName_addCNAME_lable": "Automatically Add CNAME Record",
    "obs_term_domainName_addCNAME_notSupport_tip": "After adding the domain name, you need to configure a CNAME record for the domain name at your DNS provider to make the CDN configuration effective.",
    "obs_term_domainName_bindSuccess_msg": "The domain name added successfully.",
    "obs_term_domainName_add_button": "Add Domain Name",
    "obs_term_domainName_cdnAutoFresh_column": "Auto Refresh of CDN Cache",
    "obs_term_domainName_cdnCNAME_column": "CDN Acceleration Domain Name",
    "obs_term_domainName_cdnCNAMEStatus_column": "CDN Acceleration Status",
    "obs_term_domainName_cdnCNAMEStatus_online_column": "Enabled",
    "obs_term_domainName_cdnCNAMEStatus_offline_column": "Disabled",
    "obs_term_domainName_cdnCNAMEStatus_configuring_column": "Configuring",
    "obs_term_domainName_cdnCNAMEStatus_configureFailed_column": "Configuration failed",
    "obs_term_domainName_cdnCNAMEStatus_checking_column": "Auditing",
    "obs_term_domainName_cdnCNAMEStatus_checkFailed_column": "Rejected",
    "obs_term_domainName_cdnCNAMEStatus_deleting_column": "Deleting",
    "obs_term_domainName_cdnCNAME_copySuccess_msg": "CDN Acceleration Domain Name copied successfully.",
    "obs_term_domainName_cdnType_lable": "Service Type",
    "obs_term_domainName_cdnTypeWeb_option": "Website",
    "obs_term_domainName_cdnTypeDownload_option": "File download",
    "obs_term_domainName_cdnTypeVOD_option": "On-demand service",
    "obs_term_domainName_cdn_lable": "CDN Acceleration",
    "obs_term_domainName_cdn_tip": "1. Once CDN Acceleration is enabled, a domain name record will be added to CDN. If you have not enabled CDN, the system will enable it automatically and then add the domain name record.",
    "obs_term_domainName_cdnDelay_tip": "2. CDN Acceleration does not take effect immediately. After binding the domain name, refresh the domain name list to check the status. CDN Acceleration takes effect only when the CDN Acceleration status of the domain name is Enabled.",
    "obs_term_domainName_cdnPrice_tip": "CDN Pricing Details",
    "obs_term_domainName_info": "You can set the bucket as the origin server for CDN acceleration.  Add the domain name and enable CDN on OBS Console. Once configured, you can see the added domain names on OBS Browser, and enable CDN download for the bucket on OBS Browser. The system retrieves objects from optimal CDN nodes when you use OBS Browser to download objects from the bucket.",
    "obs_term_domainName_manageCDN_button": "Manage CDN Acceleration",
    "obs_term_domainName_menu": "Configure CDN Download",
    "obs_term_domainName_userDomain_column": "User Domain Name",
    "obs_term_domainName_userDomain_hint": "Enter a domain name.",
    "obs_term_domainName_userDomain_valid": "Incorrect domain name format. Example: www.example.com.",
    "obs_term_domainName_userDomain_tip": "Note: The user domain name must be archived in the Ministry of Industry and Information Technology (MIIT). We will review whether the user domain name has been archived.",
    "obs_term_domainName_refreshAdd_column": "Auto Cache Refresh (at object upload)",
    "obs_term_domainName_refreshDel_column": "Auto Cache Refresh (at object deletion)",
    "obs_term_domainName_refresh_lable": "Auto Cache Refresh",
    "obs_term_domainName_refreshAdd_lable": "At object upload",
    "obs_term_domainName_refreshDel_lable": "At object deletion",
    "obs_term_domainName_openRefreshAdd_msg": "Auto cache refresh (at object upload) enabled successfully.",
    "obs_term_domainName_openRefreshDel_msg": "Auto cache refresh (at object deletion) enabled successfully.",
    "obs_term_domainName_closwRefreshAdd_msg": "Auto cache refresh (at object upload) disabled successfully.",
    "obs_term_domainName_closeRefreshDel_msg": "Auto cache refresh (at object deletion) disabled successfully.",
    "obs_term_domainName_cdnDownload_lable": "Enable CDN Download",
    "obs_term_domainName_cdnDownload_msg": "CDN download configured successfully.",
    "CDN.0000": "System error.",
    "CDN.0001": "The parameter format is incorrect or a parameter is missing.",
    "CDN.0002": "The account is not authorized.",
    "CDN.0003": "The object does not exist.",
    "CDN.0004": "You have insufficient permissions.",
    "CDN.0005": "The number of acceleration domain names has exceeded the upper limit.",
    "CDN.0101": "The acceleration domain name has been added.",
    "CDN.0102": "The acceleration domain name failed to be approved.",
    "CDN.0103": "The origin server failed to be approved.",
    "CDN.0104": "The number of acceleration domain names has reached the upper limit.",
    "CDN.0105": "The acceleration domain name has not been added.",
    "CDN.0106": "The status is not operable.",
    "CDN.0107": "The retrieval host failed to be approved.",
    "CDN.0108": "The domain name does not belong to the current tenant.",
    "CDN.0109": "The origin server domain name cannot be the same as its acceleration domain name.",
    "CDN.0110": "The number of URLs has exceeded the upper limit.",
    "CDN.0114": "CDN is not enabled.",
    "CDN.0115": "The domain name is Prohibited.",
    "CDN.0116": "The domain name is locked.",
    "CDN.0117": "The origin server IP address cannot be used as the retrieval host address.",
    "CDN.0120": "The domain name has been added by another user.",
    "CDN.0121": "The IP address cannot be an intranet IP address.",
    "CDN.0126": "Domain names can be deleted only when they are disabled or when they fail to be configured, audited, or synchronized.",
    "CDN.0127": "The domain name format is incorrect.",
    "CDN.0128": "The business type is incorrect.",
    "CDN.0129": "The origin server type is incorrect.",
    "CDN.0130": "The number of origin server IP addresses has exceeded the upper limit.",
    "CDN.0131": "The number of origin server domain names has exceeded the upper limit.",
    "CDN.0133": "Retrieval host error.",
    "CDN.0134": "The priority weight value must be an integer ranging from 1 to 100.",
    "CDN.0135": "The cache rule type is incorrect.",
    "CDN.0136": "The allowed time span ranges from 0 to 365 days.",
    "CDN.0137": "The cache expiration rule is invalid.",
    "CDN.0138": "The URL validation type is incorrect.",
    "CDN.0139": "The number of domain names in the referrer list ranges from 1 to 100.",
    "CDN.0141": "The domain name is not licensed.",
    "CDN.0201": "Domain name error.",
    "CDN.0202": "Statistic time error.",
    "CDN.0203": "Sampling interval error.",
    "CDN.0406": "The certificate does not match the domain name.",
    "CDN.0407": "Certificate error.",
    "CDN.0408": "The certificate has expired.",
    "CDN.0409": "The certificate expires in less than 24 hours.",
    "CDN.0410": "The certificate chain cannot be completed.",
    "CDN.0411": "The certificate status is incorrect.",
    "CDN.0412": "The content length of the certificate or private key has exceeded the upper limit.",
    "CDN.0413": "The certificate is not effective.",
    "CDN.0414": "The private key of the certificate is incorrect.",
    "obs_term_fileProFolder_cannotDel_msg": "This operation cannot be performed because the file system semantics function is enabled for the bucket.",
    "obs_term_bucketPolicy_private_info": "Only the bucket owner can read, write, and delete objects in the bucket.",
    "obs_term_bucketPolicy_private_radio": "Private",
    "obs_term_bucketPolicy_publicReadWrite_info": "Any user can read, write, and delete objects in the bucket.",
    "obs_term_bucketPolicy_publicReadWrite_radio": "Public Read and Write",
    "obs_term_bucketPolicy_publicRead_info": "Any user can read objects in the bucket. Only the bucket owner can write and delete objects in the bucket.",
    "obs_term_bucketPolicy_publicRead_radio": "Public Read",
    "obs_term_createBucket_publicRead_msg": "The Public Read policy allows any user to directly read objects in the bucket without identity authentication. To ensure data security, it is recommended that you select the Private policy.",
    "obs_term_createBucket_publicReadWrite_msg": "The Public Read and Write policy allows any user to directly read, write, and delete objects in the bucket without identity authentication. To ensure data security, it is recommended that you select the Private policy.",
    "obs_term_createBucket_private_button": "Select Private",
    "obs_term_createBucket_confirmChangePolicy_button": "Confirm Change",
    "obs_term_createBucket_region_info": "Regions are geographic areas isolated from each other. Resources are region-specific and cannot be used across regions through internal network connections. For low network latency and quick resource access, select the nearest region. Once a bucket is created, the region cannot be changed.",
    "obs_term_taskManage_noTask_tip": "This operation cannot be performed because no task exists.",
    "obs_term_delBucket_warn_msg": "Deleted bucket cannot be recovered. Exercise caution when performing this operation.",
    "obs_term_encrypted_label": "Encrypted",
    "obs_term_AZ_lable": "Multi-AZ Mode",
    "obs_term_AZ_3AZ_tip": "If a bucket is created in the 3-AZ mode, data in the bucket is stored in three different AZs in the same region. Therefore data can be properly accessed even if one AZ is not available. The 3-AZ mode applies to data storage that requires high availability.",
    "obs_term_AZ_price_tip": "The multi-AZ mode improves data availability. Storage price in the multi-AZ mode is higher.",
    "obs_term_AZ_priceDetail_tip": "Pricing details",
    "obs_term_AZ_regionNotSupport_tip": "The multi-AZ mode is available in CN East-Shanghai2, CN North-Beijing4, cn-southwest-2.",
    "obs_term_AZ_archiveNotSupport_tip": "The multi-AZ mode does not apply to buckets for Archive storage.",
    "obs_term_AZ_coldNotSupport_tip": "The multi-AZ mode does not apply to buckets for Cold storage.",
    "obs_term_AZ_canNotChange2Archive_tip": "Note: The bucket is in the multi-AZ mode, and its storage class cannot be changed to Archive.",
    "obs_term_AZ_canNotChange2Cold_tip": "Note: The bucket is in the multi-AZ mode, and its storage class cannot be changed to Cold.",
    "common_term_lengthLimit_tip": "Enter a maximum of {0} characters.",
    "common_term_accessDenied_msg": "Access denied",
    "common_term_accessPath_msg": "Enter a path that you can access in the address bar.",
    "obs_term_copyObjectLink_btn" : "Copy Link",
    "obs_term_modifyDBPath_msg" : "Database path cannot contain any Chinese character. Change the path and click OK. OBS Browser shuts down automatically. You need to restart it to make the path effective.",
    "obs_term_copyDomain_copySeccess_msg": "Access domain name copied successfully.",
    "obs_term_copyEndpoint_copySeccess_msg": "Endpoint copied successfully.",
    "obs_term_copyAccountID_copySeccess_msg": "Account ID copied successfully.",
    "obs_term_shareObject_button" : "Share",
    "obs_term_shareObject_wintitle" : "Share File",
    "obs_term_shareObject_fileName_label" : "File Name",
    "obs_term_shareObject_urlValidity_label" : "URL Validity Period",
    "obs_term_shareObject_urlValidity_tip" : "Any user can access the file through the URL within the validity period.",
    "obs_term_shareObject_urlValidity_valid1" : "- If you use a pair of temporary AK/SK, the validity period is an integer ranging from 1 to 1,080.",
    "obs_term_shareObject_urlValidity_valid2" : "- The validity period is an integer ranging from 1 to 20,160.",
    "obs_term_shareObject_urlValidityInput_valid" : "Enter an integer ranging from 1 to {0}.",
    "obs_term_shareObject_url_label" : "URL",
    "obs_term_shareObject_copyUrl_button" : "Copy URL",
    "obs_term_shareObject_copyUrlSuccess_msg" : "The URL has been copied to the clipboard.",
    "obs_term_shareObject_openUrl_button" : "Open URL",
    "obs_term_shareObject_copyPath_button" : "Copy Path",
    "obs_term_shareObject_copyPathSuccess_msg" : "The file path has been copied to the clipboard.",
    "obs_term_shareObject_akskExpired_msg" : "Failed to generate a URL for the current file, because the expiration time of the temporary AK/SK is not obtained.",
    "obs_term_shareObject_kmsDisabled_tip" : "This operation cannot be performed because you do not have the KMS administrator permission or the key that encrypted the file is frozen or disabled on KMS.",
    "obs_term_shareObject_restoring_tip" : "This operation cannot be performed because the file is unrestored or restoring.",
    "obs_term_shareObject_encrypted_tip" : "This operation cannot be performed because the files are encrypted.",
    "obs_term_uploadSync_disable_tip" : "After the incremental upload is disabled, objects to be uploaded will overwrite the namesake objects in the bucket.",
    "obs_term_uploadSync_enable_tip" : "After Incremental Upload is enabled, objects to be uploaded are compared with objects in the target bucket. They are uploaded only when their contents are different, or no namesake objects in the bucket.",
    "obs_term_uploadSync_label" : "Incremental Upload",
    "obs_term_taskManage_status_skip_value" : "Skipped",
    "obs_term_fileProtocol_label" : "File System Semantics",
    "obs_term_filePro_regionNotSupport_tip" : "The file system semantics feature is available in CN East-Shanghai2, CN North-Beijing1.",
    "common_term_collect_button" : "Add to Favorites",
	"obs_term_collectPath_tab" : "Favorite Paths",
	"obs_term_collectPath_add_button" : "Add Path ({0}/100)",
	"obs_term_collectPath_add_tip_00001" : "Path format: Bucket name/Folder name/../../",
	"obs_term_collectPath_added_msg" : "The path {0} has been added to Favorites.",
	"obs_term_collectPath_canceled_msg" : "The path {0} has been removed from Favorites.",
	"common_term_cancelCollect_button" : "Cancel Favorite",
	"obs_term_collectPath_valid_00001" : "Enter the bucket name and folder name in the required format.",
	"obs_term_collectPath_valid_00002" : "Invalid bucket name or folder name format.",
	"obs_term_collectPath_valid_00003" : "The total path length cannot exceed 1,023 characters.",
	"obs_term_collectPath_upperLimit_msg" : "The number of favorite paths has reached the upper limit of 100.",
	"obs_term_collectPath_add_wintitle" : "Add Favorite Path",
	"obs_term_collectPath_alreadyExists_msg" : "The path already exists. Enter another path.",
    "obs_term_enableKMS_tip": "After KMS encryption is enabled, objects uploaded to buckets are encrypted by keys hosted on KMS.",
    "obs_term_fileProtocol_onlyStandard_tip":"Only buckets in the Standard storage class support the file system semantics function. Change the storage class or disable file system semantics.",
    "obs_term_fileProtocol_tip":"Enabling the file system semantics function allows you to modify files in the bucket online on OBS.",
    "obs_term_accesscode_label" : "Extraction Code",
    "common_term_accountName_tip" : "The account name can contain only digits, letters, and the following special characters: , . - _",
    "obs_term_shareFolder_column" : "Folder Name",
    "obs_term_accesscode_tip" : "Enter a six-digit extraction code.",
    "obs_term_shareFolder_wintitle" : "Share Folder",
    "common_term_accesscode_label" : "minutes",
    "obs_term_shareFolder_msg" : "Enter a valid period.",
    "obs_term_accesscode_button" : "Create Share",
    "obs_term_accesscode_labelto" : "Expires At:",
    "obs_term_login_button" : "Account Login",
    "obs_term_login_button_share" : "Obtain Share",
    "obs_term_accesscode_tip_warning" : "Incorrect format. Enter a six-digit extraction code.",
    "obs_term_shareFolder_msg_warning" : "Incorrect format. Enter an integer between 1 and {0}.",
    "obs_term_share_column":"Share Link",
    "obs_term_accesscodeCopy_msg":"Link copied successfully.",
    "obs_term_accesscode_msg_warning":"Incorrect link or extraction code. Try again.",
    "obs_term_accesscodeExpire_label":"The share expires at",
    "obs_term_accesscodeAccessDenied_msg":"Validity period of the share expired. Access is denied.",
    "obs_term_KMS_label":"(KMS encryption is not supported by buckets that have enabled the file system semantics.)",
    "obs_term_KMS_label2":"KMS encryption is not supported by buckets that have enabled the file system semantics.",
    "obs_term_obsutil_link":"Learn more",
    "obs_term_obsutil_msg":"The CLT tool obsutil is recommended for easy use and excellent performance.",
    "obs_term_uploadSync_msg":"Incremental upload is not supported when a selected folder already contains a selected file. Delete the duplicated file or disable incremental upload.",
    "obs_term_createFolder_ruler0_valid": "Enter a folder name.",
    "obs_term_createFolder_ruler1_valid": "The absolute path of the folder cannot exceed 1023 characters.",
    "obs_term_createFolder_ruler2_valid": "The name of a single-level folder cannot contain the following characters: \\ : * ? \" < > |",
    "obs_term_createFolder_ruler3_valid": "The name cannot start or end with a period (.) or a slash (/).",
    "obs_term_createFolder_ruler4_valid": "Use single slashes (/) to separate levels of a folder.",
    "obs_term_createFolder_ruler5_valid": "Cannot contain two or more consecutive slashes (/).",
    "obs_term_createFolder_ruler6_valid": "You can create folders with a single level or multiple levels.",
    'obs_term_share_object_expire_time_minute': 'minutes',
    'obs_term_share_object_expire_time_hour': 'hours',
    'obs_term_share_object_expire_time_day': 'days',
    'obs_term_share_object_expire_time_week': 'weeks',
    'obs_term_share_folder_link_info_label': 'URL Info',
    'obs_term_share_folder_copy_link_info': 'Copy URL Info',
    'obs_term_share_folder_copy_share_code': 'Copy Extraction Code',
    'obs_term_share_folder_copy_link_succeed': 'The URL copied successfully.',
    'obs_term_share_folder_copy_link_info_success': 'The extraction code copied successfully.',
    "obs_term_posix_tab" : "Parallel File System",
    'obs_term_bucket_type_label': 'Bucket Type',
};
