
//呼出桶右键菜单
$("#bucketLists tbody").delegate('tr', 'contextmenu', function (ev) {
    ev.preventDefault();
    $(this).click();
    showRightClkBucket();
    handleExtbucket();//外部桶桶属性按钮隐藏
    $('.bucketCtxMenu').addClass('mui-active');
    //计算窗口位置
    var dx = $(window).width() - ev.originalEvent.x;
    var dy = $(window).height() - ev.originalEvent.y;

    var menuWidth = $('.bucketCtxMenu li').width()+2;
    var menuHeight = $('.bucketCtxMenu').height()+2;

    var popX = dx < menuWidth ? $(window).width() - menuWidth : ev.originalEvent.x;
    var popY = dy < menuHeight ? $(window).height() - menuHeight : ev.originalEvent.y;
    $('#bucketCtxMenu').css({left: popX, top: popY - 60});

    // 检查是否为伙伴云节点，当前设置默认伙伴云为法电（eu-west-0）
    var region = $(ev.target).parents('tr').find('span[name="region"]').text();
    var $ctxmenu = $('.bucketCtxMenu');
    if (global.isPartnerCloudF(region)) {
        window.isPartnerCloud = true;
        $('.bucket-delete,.mui-icon-aclConfig').addClass('mui-disabled').removeAttr('data-title').attr('disabled');
        $ctxmenu.find('li>.btcConfigPermisson').addClass('mui-disabled-task');
        $ctxmenu.find('li>.btnConfigPolicy').addClass('mui-disabled-task');
        $ctxmenu.find('li>.btnCDN').addClass('mui-disabled-task');
    } else {
        window.isPartnerCloud = false;
        $('.bucket-delete,.mui-icon-aclConfig').removeAttr('disabled').removeClass('mui-disabled');
        $ctxmenu.find('li>.btcConfigPermisson').removeClass('mui-disabled-task');
        $ctxmenu.find('li>.btnConfigPolicy').removeClass('mui-disabled-task');
        $ctxmenu.find('li>.btnCDN').removeClass('mui-disabled-task');
    }
    var fsType = $(ev.target).parents('tr').find('span[name="fsType"]').text().trim();
    // 开启文件语义的桶屏蔽掉部分功能:生命周期管理,cdn/自定义域名,cors配置,website配置,温冷特性相关功能
    // 这里暂时放开所有右键菜单，灰度客户右键文件语义桶点击不支持的操作，会提示不支持
    // $(".btnConfigLifecycle, .btnConfigCors, .btnCDN").addClass('mui-hide');
    // if(fsType == "Disabled"){
    //     $(".btnConfigLifecycle, .btnConfigCors, .btnCDN").removeClass('mui-hide');
    // }
    if(!pkg.CDNCoonfig){
        $(".btnCDN").addClass("mui-hide");
    }
    return false;
});
//桶列表空白处右键菜单
$("#bucketBodyDiv").on('contextmenu', function (ev) {
    ev.preventDefault();
    $(this).click();
    handleEmpytRightClick();
    $('.bucketCtxMenu').addClass('mui-active');
    //计算窗口位置
    var dx = $(window).width() - ev.originalEvent.x;
    var dy = $(window).height() - ev.originalEvent.y;

    var menuWidth = $('.bucketCtxMenu li').width()+2;
    var menuHeight = $('.bucketCtxMenu').height()+2;

    var popX = dx < menuWidth ? $(window).width() - menuWidth : ev.originalEvent.x;
    var popY = dy < menuHeight ? $(window).height() - menuHeight : ev.originalEvent.y;
    $('.bucketCtxMenu').css({left: popX, top: popY - 60});
    return false;
});
$(".btcConfigProperty").on("click", function () {
    $('.mui-icon-property').click();
})
$(".btcConfigPermisson").on("click", function () {
    $('.mui-icon-aclConfig').click();
})
$(".btcConfigDelete").on("click", function () {
    $('.bucket-delete').click();
})
$(".btcConfigOpen").on("click", function () {
    $("#bucketLists .show-span-active").click();
})
$(".btcConfigRefresh").on("click", function() {
    $("#all-refresh-div").click();
})
$(".changeStorageTypeCtx").on("click", function() {
    $("#changeStorageTypeInMore").click();
})
$(".ObjectACLCtx").on("click", function() {
    $("#ObjectAcl").click();
})
$(".ObjectPolicyCtx").on("click", function() {
    $("#PolicyBtn").click();
})
//呼出对象folder右键菜单
$("#objLists tbody").delegate('tr','contextmenu', function(ev) {
    ev.preventDefault();
    $(this).click();
    $("#allObject").get(0).checked = false;
    $(".objectCheckbox").each(function () {
        $(this).get(0).checked = false;
        $(this).removeClass('ObjectChecked');
    })
    handleObjOrFolderRc();
    if($(this).hasClass('folder')){//当选择文件夹时，不显示属性项
        if(global.curFileInterface === "Enabled"){
            $(".restoreCtx").parent().addClass('mui-hide');
            $(".restoreCtx").addClass("mui-disabled-task");
            $(".restoreCtx").parent().attr("title",languageJson.ERR_CODE_FsNotSupport);
        }else {
            if(pkg.objectColdline){
                $(".restoreCtx").parent().removeClass('mui-hide');
                $(".restoreCtx").removeClass("mui-disabled-task");
                $(".restoreCtx").parent().attr("title","");
            }
        }
        $(".copyObjectUrlCtx").parent().addClass('mui-hide');
        $(".objectAttrCtx").parent().addClass('mui-hide');
        $(".openFolderCtx").parent().removeClass('mui-hide');
        $(".changeStorageTypeCtx").parent().addClass('mui-hide');
        $(".ObjectACLCtx").parent().addClass('mui-hide');
        $(".renameCtx").parent().addClass("mui-hide");
        $(".shareObjectCtx").parent().addClass("mui-hide");

    }else{
        var hiddenObjData = $(this).find(".hiddenObjData").text();
        hiddenObjData = JSON.parse(hiddenObjData);
        var storage = hiddenObjData.StorageClass;
        storage = commonUtils.termStorageClass(storage);
        var a = "";
        var inputs = $("#StorageClassdsc").parent().find("input");
        for (var index in inputs){
            if (commonUtils.termStorageClass(inputs[index].value) == storage){
                a = index;
            }
        };
        var appElements = document.getElementById("changeStorageClass");
        var $scope = angular.element(appElements).scope();
        $scope.object.selected.value = $scope.object.storageTypeList[a].key;
        $scope.object.description = $scope.object.storageTypeList[a].desc;
        $scope.$apply();
        $(".copyObjectUrlCtx").parent().removeClass('mui-hide');
        if(global.bucketVersion){
            $(".shareObjectCtx").parent().removeClass('mui-hide');
        }else{
            $(".shareObjectCtx").parent().addClass("mui-hide");
        }
        $(".renameCtx").parent().removeClass("mui-hide");
        $(".deleteCtx").removeClass('mui-disabled-task');
        $(".deleteCtx").parent().attr("title", '');
        if(pkg.objCopy){
            $(".renameCtx").removeClass("mui-hide");
        }else{
            $(".renameCtx").addClass("mui-hide");
        }
        $(".objectAttrCtx").parent().removeClass('mui-hide');
        $(".openFolderCtx").parent().addClass('mui-hide');
        if(pkg.objectColdline){
            $(".changeStorageTypeCtx").parent().removeClass('mui-hide');
            $(".restoreCtx").parent().removeClass('mui-hide');
        }else {
            $(".changeStorageTypeCtx").parent().addClass('mui-hide');
            $(".restoreCtx").parent().addClass('mui-hide');
        }
        $(".ObjectACLCtx").parent().removeClass('mui-hide');
        // CMCC 暂时屏蔽对象ACL操作
        if(_.isEqual(UCDVersion,"CMCC")){
            $(".ObjectACLCtx").parent().addClass('mui-hide');
        }
    }
    if($('#bucketLists .selected-tr-active .show-span-active').hasClass('mui-icon-extBucket')){//判断被选择的桶是否为外部桶
        $(".ObjectPolicyCtx").parent().addClass("mui-hide");
    } else {
        $(".ObjectPolicyCtx").parent().removeClass("mui-hide");
    }
    $('#objectCtxMenu').addClass('mui-active');
    var objectStorage = getChoseObjType();
    if (_.isEqual($(this).attr('data-type'), "folder")) {//文件夹允许下载
        $(".downloadCtx").removeClass('mui-disabled-task');
        $(".downloadCtx").parent().removeAttr('title');
    } else if(pkg.coldline){//冷对象需要判断对象是否为恢复对象
        if (objectStorage === 'Coldline' || objectStorage === "GLACIER"){
            var restoreState = $(this).find('.restore_stat').text();
            if(restoreState){//页面有恢复状态才根据页面判断
                if (_.isEqual($(this).find('.restore_stat').text(), languageJson.obs_term_restored_lable)) {//对象为已恢复对象
                    $(".downloadCtx").removeClass('mui-disabled-task');
                    $(".downloadCtx").parent().removeAttr('title');
                    if(global.curFileInterface === "Enabled"){
                        $('.changeStorageTypeCtx').parent().addClass("mui-hide");
                        $('.changeStorageTypeCtx').addClass("mui-disabled-task");
                        $('.changeStorageTypeCtx').parent().attr('title',languageJson.ERR_CODE_FsNotSupport);
                    }else {
                        $('.changeStorageTypeCtx').parent().removeClass("mui-hide");
                        $('.changeStorageTypeCtx').removeClass("mui-disabled-task");
                        $('.changeStorageTypeCtx').parent().attr('title',"");
                    }
                    $('.shareObjectCtx').removeClass("mui-disabled-task");
                    $('.shareObjectCtx').parent().attr('title',"");
                }else{
                    $(".downloadCtx").addClass('mui-disabled-task');
                    $(".downloadCtx").parent().attr('title', languageJson.ERR_CODE_InvalidObjectState);
                    $('.changeStorageTypeCtx').addClass("mui-disabled-task");
                    $('.changeStorageTypeCtx').parent().attr('title',languageJson.obs_task_changeStorageClassUnavailable_tip);
                    $('.shareObjectCtx').addClass("mui-disabled-task");
                    $('.shareObjectCtx').parent().attr('title',languageJson.obs_term_shareObject_restoring_tip);
                }
                if (_.isEqual($(this).find('.restore_stat').text(), languageJson.obs_term_restoring_lable)) { //对象为恢复中对象
                    $(".restoreCtx").parent().removeClass('mui-hide');
                    $(".restoreCtx").addClass("mui-disabled-task");
                    $(".restoreCtx").parent().attr("title",languageJson.obs_task_restoreUnavailable_tip);
                }else {
                    $(".restoreCtx").parent().removeClass('mui-hide');
                    $(".restoreCtx").removeClass("mui-disabled-task");
                    $(".restoreCtx").parent().attr("title","");
                }
            }else {
                $(".restoreCtx").parent().removeClass('mui-hide');
                $(".restoreCtx").addClass("mui-disabled-task");
                $(".restoreCtx").parent().attr("title",languageJson.obs_task_restoreObject_restoreOnlyCold_tip);
                $('.shareObjectCtx').removeClass("mui-disabled-task");
                $('.shareObjectCtx').parent().attr('title',"");
            }
            var path = getCurrPath();
            checkObjectRestore(path + JSON.parse($(this).find('.hiddenObjData').text()).name);//检查恢复状态
        }else{
            $(".restoreCtx").parent().attr("title",languageJson.obs_task_restoreObject_restoreOnlyCold_tip);
            $(".downloadCtx").removeClass('mui-disabled-task');
            if(global.curFileInterface === "Enabled"){
                $('.changeStorageTypeCtx').parent().addClass("mui-hide");
                $('.restoreCtx').parent().addClass("mui-hide");
                $('.changeStorageTypeCtx').addClass("mui-disabled-task");
                $('.changeStorageTypeCtx').parent().attr('title',languageJson.ERR_CODE_FsNotSupport);
                $(".restoreCtx").addClass("mui-disabled-task");
                $(".restoreCtx").parent().attr("title",languageJson.ERR_CODE_FsNotSupport);
            }else {
                $('.changeStorageTypeCtx').parent().removeClass("mui-hide");
                $('.changeStorageTypeCtx').removeClass("mui-disabled-task");
                $('.changeStorageTypeCtx').parent().attr('title',"");
                $(".restoreCtx").parent().removeClass('mui-hide');
                $(".restoreCtx").addClass("mui-disabled-task");
            }
            $('.shareObjectCtx').removeClass("mui-disabled-task");
            $(".downloadCtx").parent().removeAttr('title');
            $('.shareObjectCtx').parent().attr('title',"");
        }
        var path = getCurrPath();
        checkObjectRestore(path + JSON.parse($(this).find('.hiddenObjData').text()).name);//检查恢复状态
        if(global.curFileInterface === "Enabled"){
            $(".restoreCtx").parent().addClass('mui-hide');
            $(".changeStorageTypeCtx").parent().addClass('mui-hide');
        }else {
            $(".restoreCtx").parent().removeClass('mui-hide');
            $(".changeStorageTypeCtx").parent().removeClass('mui-hide');
        }
    }else {
        $('.shareObjectCtx').removeClass("mui-disabled-task");
        $('.shareObjectCtx').parent().attr('title',"");
        $(".downloadCtx").removeClass('mui-disabled-task');
        $('.changeStorageTypeCtx').removeClass("mui-disabled-task");
        $(".downloadCtx").parent().removeAttr('title');
        $('.changeStorageTypeCtx').parent().attr('title',"");
    }

    copyMoveOptionDisplay();
    //计算窗口位置
    var dx = $(window).width() - ev.originalEvent.x;
    var dy = $(window).height() - ev.originalEvent.y;

    var menuWidth = 182;
    var menuHeight = $('.objectCtxMenu').height()+2;
    var popX = dx < menuWidth ? $(window).width() - menuWidth : ev.originalEvent.x;
    var popY = dy < menuHeight ? $(window).height() - menuHeight : ev.originalEvent.y;
    $('#objectCtxMenu').css({left: popX, top: popY - 60});

    // 检查是否为伙伴云节点，当前设置默认伙伴云为法电（eu-west-0）
    var $ctxmenu = $('#objectCtxMenu')
    if (window.isPartnerCloud) {
        var region = window.partnerCloudName;
        $ctxmenu.find('li>.ObjectACLCtx').addClass('mui-disabled-task');
        $ctxmenu.find('li>.ObjectPolicyCtx').addClass('mui-disabled-task');
    } else {
        $ctxmenu.find('li>.ObjectACLCtx').removeClass('mui-disabled-task');
        $ctxmenu.find('li>.ObjectPolicyCtx').removeClass('mui-disabled-task');
    }
    return false;
});
//对象列表空白处右键菜单

$("#listObjBodyDiv").on('contextmenu', function(ev) {
    ev.preventDefault();
    $(this).click();
    handleEmptyRc();
    $("#allObject").get(0).checked = false;
    $(".objectCheckbox").each(function () {
        $(this).get(0).checked = false;
        $(this).removeClass('ObjectChecked');
    });
    if($(this).hasClass('folder')){//当选择文件夹时，不显示属性项
        $(".objectAttrCtx").parent().addClass('mui-hide');
        $(".openFolderCtx").parent().removeClass('mui-hide');
        $(".changeStorageTypeCtx").parent().addClass('mui-hide');
    }else{
        $(".objectAttrCtx").parent().removeClass('mui-hide');
        $(".openFolderCtx").parent().addClass('mui-hide');
    }
    if(global.shareDownload){
        $(".uploadFileCtx").parent().addClass("mui-hide");
        $(".createFolderCtx").parent().addClass("mui-hide");
    }else{
        $(".uploadFileCtx").parent().removeClass("mui-hide");
        $(".createFolderCtx").parent().removeClass("mui-hide");
    }
    $('#objectCtxMenu').addClass('mui-active');
    copyMoveOptionDisplay();
    $(".copyCtx").hide();
    $(".moveCtx").hide();
    $("#ctxCopyMoveLine").hide();
    //计算窗口位置
    var dx = $(window).width() - ev.originalEvent.x;
    var dy = $(window).height() - ev.originalEvent.y;

    var menuWidth = 182;
    var menuHeight = $('.objectCtxMenu').height()+2;
    var popX = dx < menuWidth ? $(window).width() - menuWidth : ev.originalEvent.x;
    var popY = dy < menuHeight ? $(window).height() - menuHeight : ev.originalEvent.y;
    $('#objectCtxMenu').css({left: popX, top: popY - 60});
    return false;
})

$(".createFolderCtx").on("click", function(){
    $('.mui-icon-newFolder').click();
});
$(".downloadCtx").on("click", function(){
    $('#downloadbtn').click();
});
$(".deleteCtx").on("click", function(){
    if($(this).hasClass('mui-disabled-task')){
        return;
    }
    $('#btnDeleteObjects').click();
});
$(".refreshCtx").on("click", function(){
    $("#all-refresh-div").click()
});
$(".objectAttrCtx").on("click", function(){
    $("#propBtn").click()
});
$(".uploadFileCtx").on("click", function(){
    $("#uploadFiles").click()
});
$(".uploadFolderCtx").on("click", function(){
    $("#uploadFolders").click()
});
$(".shareObjectCtx").on("click", function(){
    $("#shareInMore").click()
});
$(".openFolderCtx").on("click", function(){
    $("#objLists .show-span-active").click();
});
$(".restoreCtx").on("click", function(){
    $(this).parent().parent().click();
    disabledBtn($("#recoverBtn"));
    $("#recoverBtn").click();
});

// 复制内容到剪贴板
function copyToClipboard (text, copySuccessMsg) {
    var textArea = document.createElement("textarea");
    textArea.style.position = 'fixed';
    textArea.style.top = '0';
    textArea.style.left = '0';
    textArea.style.width = '2em';
    textArea.style.height = '2em';
    textArea.style.padding = '0';
    textArea.style.border = 'none';
    textArea.style.outline = 'none';
    textArea.style.boxShadow = 'none';
    textArea.style.background = 'transparent';
    textArea.value = text;
    document.body.appendChild(textArea);
    textArea.select();

    try {
        var successful = document.execCommand('copy');
        if(successful){
            $('.mui-model').showMessage({//增加复制成功提示信息
                type:"info",
                message:copySuccessMsg,
                ok:function(){
                    return false;
                },
                title:languageJson.info
            });
        }
    } catch (err) {
        global.logger.error("The browser don't support copying to clipboard:", err);
    }

    document.body.removeChild(textArea);
}

$(".copyObjectUrlCtx").on("click", function(){
    var bName = $("#curBucketName").html();
    var href = JSON.parse($("#objLists .selected-tr-active .hiddenObjData").text()).name;
    var parentPath = getCurrPath();
    bucketAttributeAction.headBucket(bName, function (err, data) {
        var region = "";
        if(err){
            region = "-";
        }else{
            region = data.LocationConstraint;
        }
        var urlText = getObjectUrl(bName, href, region, parentPath);
        copyToClipboard(urlText, languageJson.copySuccess);
    })

});

// 分享里面的打开url
$("#shareUrlLink").on("click",function(){
    var gui = require('nw.gui');
    var href = $("#shareUrl").val();
    gui.Shell.openExternal(href);
});

// 分享里面的复制url
$("#copyShareUrl").on("click",function(){
    var urlText = $("#shareUrl").val().trim();
    copyToClipboard(urlText, languageJson.obs_term_shareObject_copyUrlSuccess_msg);
});

// 分享里面的复制路径
$("#copySharePath").on("click",function(){
    var objectName = $("#shareObjectName").html();
    var parentPath = getCurrPath();
    var path = parentPath + objectName;
    copyToClipboard(path, languageJson.obs_term_shareObject_copyPathSuccess_msg);
});

function copyMoveOptionDisplay() {
    var isExt = $("#curBucketName").attr("isExt");
    if (pkg.objCopy) {
        $(".copyCtx").show();
        $(".moveCtx").show();
        $(".pasteCtx").show();
        $("#ctxCopyMoveLine").show();
    } else {
        $(".copyCtx").hide();
        $(".moveCtx").hide();
        $(".pasteCtx").hide();
        $("#ctxCopyMoveLine").hide();
    }
    //todo 判断剪贴板中是否有数据，有则paste可用
    var sameBucket = global.glbClipboard.bucket === $("#curBucketName").html();
    var samePath = global.glbClipboard.location === getCurrPath();
    if (global.glbClipboard.empty || (sameBucket && samePath)) {
        $(".pasteCtx").hide();
        $("#pastebtn").addClass("mui-disabled");
        $("#pastebtn").text(languageJson.obs_term_pasteObject_button);
        $("#pastebtn").attr("data-title",languageJson.obs_term_pasteObject_tip)
    } else {
        var pasteShow = languageJson.obs_term_pasteObject_button + "(" + global.glbClipboard.contents.length + ")";
        $(".pasteCtx").show();
        $("#pastebtn").text(pasteShow);
        disabledBtn($("#pastebtn"));
    }
}

/**
 * 判断所选择的桶是否是外部桶，如果是则不显示桶属性功能按钮
 */
function handleExtbucket(){
    if($('#bucketLists .selected-tr-active .show-span-active').hasClass('mui-icon-extBucket')){//判断被选择的桶是否为外部桶
        $(".btnConfigLifecycle,.btcConfigProperty,.btnConfigPolicy,.btnConfigCors,.btnBucketLogging,.btcConfigDelete").addClass('mui-hide');
        $(".btnListMultipart,.btcBucketUnlink").removeClass('mui-hide');
    }else{
        $(".btnConfigLifecycle,.btcConfigProperty,.btnListMultipart,.btnConfigPolicy,.btnConfigCors,.btnBucketLogging,.btcConfigDelete").removeClass('mui-hide');
        $(".btcBucketUnlink").addClass('mui-hide');
    }
}

/**
 * 判断所选择的桶是否是外部桶，如果是则不显示桶属性功能按钮
 */
function handleEmpytRightClick(){
    $(".btcConfigOpen, .btcConfigDelete, .btcConfigProperty, .ctxMenuGroup,.btnListMultipart,.btcConfigPermisson, .btnConfigLifecycle,.btcConfigProperty,.btnConfigPolicy,.btnConfigCors,.btnBucketLogging,.btnCDN,.btcBucketUnlink").addClass('mui-hide')
}
function showRightClkBucket(){
    $(".btcConfigOpen, .btcConfigDelete, .btcConfigProperty, .ctxMenuGroup,.btnListMultipart,.btcConfigPermisson, .btnConfigLifecycle,.btcConfigProperty,.btnConfigPolicy,.btnConfigCors,.btnBucketLogging").removeClass('mui-hide')
}
function handleObjOrFolderRc(){
    $(".ctxMenuGroup, .uploadFileCtx, .uploadFolderCtx, .createFolderCtx").addClass("mui-hide");
    $(".openFolderCtx, .downloadCtx, .deleteCtx, .objectAttrCtx,.ObjectACLCtx,.changeStorageTypeCtx,.ObjectPolicyCtx,.restoreCtx,.copyObjectUrlCtx").removeClass("mui-hide");
}
function handleEmptyRc(){//对象列表空白处显示隐藏
    $(".ctxMenuGroup, .uploadFileCtx, .uploadFolderCtx, .createFolderCtx").removeClass("mui-hide");
    $(".openFolderCtx, .downloadCtx, .deleteCtx, .objectAttrCtx, .changeStorageTypeCtx,.ObjectACLCtx,.ObjectPolicyCtx,.renameCtx,.restoreCtx,.copyObjectUrlCtx").addClass("mui-hide");
    $(".shareObjectCtx").parent().addClass("mui-hide");
}